;********************************************
;*                                          *
;*  TINY BASIC INTERPRITER TDU Version 1.5  *
;*  For Pic                                 *
;*                                          *
;*  Bequest333                              *
;*  Test Version 0.98                       *
;*  2018.06.29                              *
;*                                          *
;********************************************
;
	RADIX 	DEC
	LIST	p=16f1705
#include	"p16f1705.inc"
#include	"6800macro.inc"
#define	_RAMEND	0x23EF		;PIC16F1705
#define	ROMTOP	0x8900		;++
#define	ROMBTM	0x9F9F		;++

    __CONFIG _CONFIG1, _FOSC_INTOSC & _WDTE_OFF & _PWRTE_ON & _MCLRE_ON & _CP_OFF & _BOREN_OFF & _CLKOUTEN_OFF & _IESO_OFF & _FCMEN_OFF
    __CONFIG _CONFIG2, _WRT_OFF & _PPS1WAY_OFF & _ZCDDIS_OFF & _PLLEN_OFF & _STVREN_OFF & _BORV_LO & _LPBOR_OFF & _LVP_OFF

	cblock	0x20		;       ORG	$001A
	V:2		;0x20	;V	RMB	2
	_W:2		;0x22	;W	RMB	2
	_Z:2		;0x24	;Z	RMB	2
	RND:2		;0x26	;RND	RMB	2
	LN:2		;0x28	;LN	RMB	2
	PX:2		;0x2A	;PX	RMB	2
	SP:2		;0x2C	;SP	RMB	2
	LNADRS:2	;0x2E	;LNADRS	RMB	2
	BUFEND:2	;0x30	;BUFEND	RMB	2
	LDFLG		;0x32	;LDFLG	RMB	1
	AFLG		;0x33	;AFLG	RMB	1
	CHCNT		;0x34	;CHCNT	RMB	1
	_F		;0x35	;F	RMB	1
				;BUFFER	RMB	80
				;EXSTK	EQU	*
	EXSP:2		;0x36	;EXSP	RMB	2
	ATOZ:52		;0x38	;	RMB	52
	PRSTRT:2	;0x6C	;PRSTRT	RMB	2
	PREND:2		;0x6E	;PREND	RMB	2
				;RAMEND	RMB	2
	SUBSP:2		;0x70	;SUBSP	RMB	2
	FORSP:2		;0x72	;FORSP	RMB	2
				;	RMB	64
				;FORSTK	EQU	*
	Areg		;0x74
	Breg		;0x75
	XHreg		;0x76
	XLreg		;0x77
	SHreg		;0x78
	SLreg		;0x79
	Temp		;0x7A
	TSTATUS		;0x7B
	TAreg		;0x7C
	TBreg		;0x7D
	THreg		;0x7E
	TLreg		;0x7F
	endc
				;For PROGRAM LOADER
crc	equ	TSTATUS		;**
i	equ	TAreg		;**
cnt1	equ	TBreg		;**
cnt2	equ	THreg		;**
cnt3	equ	TLreg		;**

BUFFER	equ	0x70-0x20+0x2000	;UMTOP   EQU  	$0940
EXSTK	equ	BUFFER+80		;UMBTM   EQU  	$7FFF
FORSTK	equ	EXSTK+64		;BRKCHK  EQU  	$8004
STACK	equ	FORSTK+0x37		;STACK   EQU	$A047
SUBBTM	equ	STACK+3			;SUBBTM  EQU  	$A04A
SUBSTK	equ	FORSTK+0x60		;SUBSTK  EQU	$A080
UMTOP	equ	SUBSTK			;INEEE	 EQU	$E1AC
UMBTM	equ	_RAMEND-0xF0		;OUTEEE  EQU	$E1D1
SHS	equ	_RAMEND			;RESET	 EQU	$E0D0
Loader  equ	0x2000-0x60


	org	0x0000
	pagesel	Loader
	goto	Loader

	org	0x0004
	nop				;Interrupt

	org	0x0010			;        ORG  	$0100
;
Cstart	call	START			;	 JSR  	START
Hstart  goto	CONTRL			;	 JMP  	CONTRL
;
					;LOADM   BSR  	IN
        				;	 CMPA 	#2
        				;	 BNE  	LOADM
        				;	 BRA  	GL2
;
GTLINE	 				;GTLINE	 LDAA 	LDFLG
					;        BNE  	LOADM
	movf 	AFLG,W			;        LDAA 	AFLG
	skpnz				;        BEQ	GL1
	bra	GL1
	LDAAI	10			;        LDAA 	#10
	CLRB				;        CLRB
	LDXI	LN			;        LDX  	#LN
	call	_ADD3			;        JSR  	ADD3
	call	PNUM			;        JSR  	PNUM
	call	OUTS			;        JSR  	OUTS
	bra	GL3			;        BRA  	GL3
GL1	LDAAI	'#'			;GL1	 LDAA 	#'#
	call	_OUT			;        JSR	OUT
GL2	LDXI	BUFFER			;GL2	 LDX  	#BUFFER
GL3	movf 	Areg,W			;GL3     EORA 	RND
	xorwf 	RND,F			;        STAA 	RND
	call	_IN			;        BSR  	IN
	CMPAI	0x0D			;        CMPA 	#$0D
	skpz				;        BNE  	GL4
	bra	GL4
	clrw				;        CLR  	0,X
	movwi	0[INDF0]
	STX  	BUFEND			;        STX  	BUFEND
	 				;        LDAA 	LDFLG
					;        BNE  	L144
NEWL2	call	NWLINE			;NEWL2   JSR  	NWLINE
L144	LDXI	BUFFER			;L144    LDX	#BUFFER
	return				;        RTS
;
GL4	CMPAI	0x18			;GL4     CMPA 	#$18
	skpz				;        BNE  	GL5
	bra	GL5
	call	NEWL2			;        BSR  	NEWL2
	bra	GL3			;        BRA  	GL3
;
GL5	CMPAI	0x0F			;GL5     CMPA 	#$0F
	skpz				;        BNE  	GL6
	bra	GL6
	LDAAI	0x5F			;        LDAA 	#$5F
	call	_OUT			;        JSR  	OUT
	CPXI  	BUFFER			;        CPX  	#BUFFER
	skpnz				;        BEQ  	GL3
	bra	GL3
	DEX				;        DEX
	bra	GL3			;        BRA  	GL3
;
GL6	CPXI  	BUFFER+70		;GL6     CPX  	#BUFFER+70
	skpnz				;        BEQ  	ERR100
	bra	ERR100
	movf	Areg,W			;        STAA 	0,X
	movwi	INDF0++			;        INX
	bra	GL3			;        BRA  	GL3
;
ERR100	LDABI 	100			;ERR100  LDAB 	#100
	goto	ERRMSG			;        JMP  	ERRMSG
;
_IN	call	INFFF			;IN    	 JSR  	INFFF
	ANDAI	0x7F			;        ANDA 	#$7F
	skpnz				;        BEQ  	IN
	bra	_IN
	CMPAI	0x7F			;        CMPA 	#$7F
	skpnz				;        BEQ  	IN
	bra	_IN
	CMPAI	3			;        CMPA 	#3
	skpz				;        BNE  	BR6
	bra	BR6
	bra	CONTRL			;        BRA  	CONTRL
;
BREAK	PSHA				;BREAK   PSHA
	banksel	PIR1			;        LDAA 	BRKCHK
	movf 	PIR1,W			;        BMI  	BR5
	movlb	.0
	btfsc 	WREG,RCIF
	call	_IN			;        BSR  	IN
BR5	PULA				;BR5     PULA
BR6	return				;BR6     RTS
;
INIT1	movf	LDFLG,F			;INIT1   LDX  	PRSTRT	;++
	skpz							;++
	bra	INIT10						;++
	LDX  	PRSTRT
	movlw	0xD0			;        TPA
	movwf	Areg			;        STAA 	0,X
	movwi	INDF0++			;        INX
	movwi	0[INDF0]		;        STAA 	0,X
L193	STX  	PREND			;        STX  	PREND
	return				;        RTS
;
INIT10	LDXI  	ROMTOP			;++
INIT20	moviw	INDF0++			;++
	incfsz	WREG,W			;++
	bra	INIT20			;++
	addfsr	FSR0,-2			;++
	bra	L193			;++
;
					;LOAD	 BSR  	INIT1
	 				;	 STAA 	LDFLG
					;        BRA  	C4
;
AUTO	movlw	0xD1			;AUTO	 TPA
	movwf	Areg
	movwf 	AFLG			;        STAA 	AFLG
	call	EXPRPP			;        JSR  	EXPRPP
	SUBAI	10			;        SUBA 	#10
	SBCBI	0			;        SBCB 	#0
SETLN	STAA 	LN+1			;SETLN   STAA 	LN+1
	STAB 	LN			;        STAB 	LN
	return				;        RTS
;
STOP	call	PRINT			;STOP	 JSR  	PRINT
        call	PSX			;	 JSR  	PSX
        bra	C3			;	 BRA  	C3
;
START	clrf	FSR0H			;START
	movlw	LOW(ATOZ)		;++
	movwf	FSR0L			;++
	movlw	.52			;++
	movwf	Temp			;++
	clrw				;++
ST2	movwi	INDF0++			;++
	decfsz	Temp,F			;++
	bra	ST2			;++
	movlw	HIGH(UMTOP)		;       LDX	#UMTOP
	movf	LDFLG,F			;++
	skpz				;++
	movlw	HIGH(ROMTOP)		;++
	movwf  	FSR0H			;        STX  	PRSTRT
	movwf	PRSTRT
	movlw	LOW(UMTOP)
	skpz				;++
	movlw	LOW(ROMTOP)		;++
	movwf	FSR0L
	movwf	PRSTRT+1
	skpz				;++
	bra	NEW			;++
         				;	 LDAA 	#$AA
MEMTST	clrw				;MEMTST  INX
        movwi	++INDF0			;	 LDAB 	1,X
        movlw	HIGH(UMBTM)		;	 STAA 	1,X
	subwf	FSR0H,W	       		;	 LDAA	1,X
        skpz				;	 STAB 	1,X
	bra	MEMTST			;	 CMPA 	#$AA
        movlw	LOW(UMBTM)		;	 BEQ  	MEMTST
	subwf	FSR0L,W
        skpz
	bra	MEMTST
	  				;        STX  	RAMEND
NEW	call	INIT1			;NEW	 BSR  	INIT1
CONTRL	LDSI	STACK			;CONTRL  LDS  	#STACK
	banksel	STKPTR			;++
	clrf	STKPTR			;++
	movlb	.0			;++
					;	 SEI
	call	INIT2			;        BSR  	INIT2
C3	call	NWLINE			;C3	 JSR  	NWLINE
	LDXI  	RDYMSG+0x8000		;        LDX  	#RDYMSG
	call	PD			;        JSR  	PD
	movlw	0xD1			;	 TPA
	movwf	Areg
	movwf 	LNADRS			;        STAA 	LNADRS
C4	LDSI  	STACK			;C4	 LDS  	#STACK
	banksel	STKPTR			;++
	clrf	STKPTR			;++
	movlb	.0			;++
	call	GTLINE			;        JSR  	GTLINE
	call	GETN			;        JSR  	GETN
	skpnc				;        BCC  	DIRECT
	bra	DIRECT
	call	SETLN			;        BSR  	SETLN
	call	EDIT			;        BSR  	EDIT
	bra	C4			;        BRA  	C4
;
EDIT	STX  	PX			;EDIT    STX  	PX
	STS  	SP			;        STS  	SP
	call	LNFD			;        BSR  	LDTST
	STX	_Z			;	 STX  	Z
	skpc				;        BCS  	INSERT
	bra	INSERT
	call	NXTL			;        BSR  	NXTL
	INX				;        INX
	TXS				;        TXS
	LDX	_Z			;        LDX  	Z
MOVE1	ASLB				;MOVE1   ASLB
	PULB				;        PULB
;	movf	Breg,W			;        STAB 	0,X
	movwi	INDF0++			;        INX
	btfss	WREG,7			;        BPL  	MOVE1
	bra	MOVE1
	skpc				;        BCC  	MOVE1
	bra	MOVE1
	DEX				;        DEX
	STX  	PREND			;        STX  	PREND
INSERT	LDX  	PX			;INSERT  LDX  	PX
	moviw	0[INDF0]		;        LDAA 	0,X
	skpnz				;        BEQ  	INS3
	bra	INS3
	movf 	PX+1,W			;        LDAA 	BUFEND+1
	subwf 	BUFEND+1,W		;        SUBA 	PX+1
	addlw	3			;        ADDA 	#3
	movwf	Areg
	movf  	PREND,W			;        LDX  	PREND
	movwf	FSR0H
	movf	PREND+1,W
	movwf	FSR0L
	addwf	Areg,W			;        ADDA 	PREND+1
	movwf	PREND+1			;        STAA 	PREND+1
	clrw				;        BCC  	L221
	addwfc	PREND,F			;        INC  	PREND
L221	call	SIZE			;L221    BSR  	SIZE
	skpnc				;        BCC  	INS2
	bra	INS2
	STX  	PREND			;        STX  	PREND
ERR110	LDABI 	110			;ERR110	 LDAB 	#110
	bra	_ERROR			;        BRA    ERROR
;
	 				;LDTST   LDAA 	LDFLG
					;        BEQ  	LNFD
	  				;        LDX  	PREND
					;        DEX
					;        SEC
					;        RTS
;
INS2	LDS  	PREND			;INS2    LDS  	PREND
	INX				;        INX
MOVE2	moviw	--INDF0			;MOVE2   DEX
	movwf	Areg			;        LDAA 	0,X
	PSHA				;        PSHA
	CPX	_Z			;        CPX  	Z
	skpz				;        BNE  	MOVE2
	bra	MOVE2
	movf  	LN,W			;        LDS  	LN
	movwi	INDF0++			;        STS  	0,X
	movf  	LN+1,W			;        INX
	movwf	INDF0
	LDS  	PX			;        LDS  	PX
	DES				;        DES
MOVE3	PULA				;MOVE3   INX
;	movf	Areg,W			;        PULA
	movwi	++INDF0			;        STAA 	0,X
	skpz				;        BNE  	MOVE3
	bra	MOVE3
INS3	LDS  	SP			;INS3    LDS  	SP
	return				;        RTS
;
INIT2					;INIT2   LDX  	#0
	clrf	AFLG			;        STX  	LDFLG
	movlw	HIGH(FORSTK)		;        LDX  	#FORSTK
	movwf  	FORSP			;        STX  	FORSP
	movlw	LOW(FORSTK)
	movwf  	FORSP+1
	movlw	HIGH(SUBSTK)		;        LDX  	#SUBSTK
	movwf  	SUBSP			;        STX  	SUBSP
	movlw	LOW(SUBSTK)
	movwf  	SUBSP+1
	movlw	HIGH(EXSTK)		;        LDX  	#EXSTK
	movwf  	FSR0H			;        STX  	EXSP
	movwf  	EXSP
	movlw	LOW(EXSTK)
	movwf  	FSR0L
	movwf  	EXSP+1
	movlw	HIGH(SHS)		;;HS
	movwf  	SHreg
	movlw	LOW(SHS)
	movwf  	SLreg
	return				;        RTS
;
DIRECT	STX  	PX			;DIRECT  STX  	PX
	LDXI	TABLE2-2+0x8000		;        LDX  	#TABLE2-2
	bra	STMT4			;        BRA  	STMT4
;
NXTL	INX				;NXTL    INX
L26D	INX				;L26D    INX
NXTL2	moviw	0[INDF0]		;NXTL2   TST  	0,X
	skpz				;        BNE  	L26D
	bra	L26D
	return				;        RTS
;
FINDER	LDX  	LNADRS			;FINDER  LDX  	LNADRS
	btfsc	FSR0H,7			;        BMI  	LNFD
	bra	LNFD
	call	L27D			;        BSR  	L27D
	skpnc				;        BCC	L294
	bra	L294
LNFD	LDX  	PRSTRT			;LNFD    LDX  	PRSTRT
L27D	LDAA 	LN+1			;L27D    LDAA 	LN+1
	LDAB 	LN			;        LDAB 	LN
	btfsc	LN,7			;        BMI  	ERR120
	bra	ERR120
	iorwf	LN+1,W			;        BNE  	LNFD3
	skpz				;        TSTA
	bra	LNFD3			;        BNE  	LNFD3
ERR120	LDABI	120			;ERR120  LDAB 	#120
_ERROR	goto	ERRMSG			;ERROR   JMP  	ERRMSG
;
L28D	call	NXTL			;L28D	 BSR  	NXTL
	INX				;        INX
LNFD3	call	CMPX			;LNFD3   BSR  	CMPX
	skpnz				;        BHI  	L28D
	return
	skpnc
	bra	L28D
L294	return				;L294    RTS
;
_IF	call	EXPRPP			;IF      JSR  	EXPRPP
	TSTB				;        TSTB
	skpz				;        BNE  	STMT3
	bra	STMT3
	TSTA				;        TSTA
	skpnz				;        BEQ  	NXTL2
	bra	NXTL2
	bra	STMT3			;        BRA  	STMT3
;
SIZE	movlw 	LOW(UMBTM)		;SIZE    LDAA 	RAMEND+1
	movf	LDFLG,F			;++
	skpz				;++
	movlw 	LOW(ROMBTM)		;++
	movwf	Areg
	movlw 	HIGH(UMBTM) 		;        LDAB 	RAMEND
	skpz				;++
	movlw 	HIGH(ROMBTM)		;++
	movwf	Breg
	SUBA 	PREND+1			;        SUBA 	PREND+1
	SBCB 	PREND			;        SBCB 	PREND
	return				;        RTS
;
;C7	goto	C3			;C7	 JMP  	C3
RUN	call	INIT2			;RUN	 BSR  	INIT2
	LDX  	PRSTRT			;        LDX  	PRSTRT
STMT	STX  	LNADRS			;STMT    STX  	LNADRS
	moviw	0[INDF0]		;        LDAA 	0,X
	sublw	0xD0		;++	;        ASLA
	skpnz			;++
	bra	C3		;++
	movlw 	HIGH(BUFFER)		;        LDAA 	LNADRS
	xorwf	LNADRS,W
	skpnz				;        BLS  	C7
	bra	C3
L2B9	addfsr	FSR0,2			;        INX
					;        INX
STMT3	call	BREAK			;STMT3   JSR  	BREAK
	STX  	PX			;        STX  	PX
	LDXI	TABLE-2+0x8000		;        LDX  	#TABLE-2
STMT4	LDSI	STACK			;STMT4	 LDS  	#STACK
	banksel	STKPTR			;++
	clrf	STKPTR			;++
	movlb	.0			;++
	call	OPRATE			;        JSR  	OPRATE
	DEX				;        DEX
STMT5	moviw	INDF0++			;STMT5   LDAA	0,X
	movwf	Areg			;        INX
	CMPAI	':'			;	 CMPA	#':
	skpnz				;	 BEQ	STMT3
	bra	STMT3
	TSTA				;	 TSTA
	skpz				;        BNE  	STMT5
	bra	STMT5
	bra	STMT			;        BRA  	STMT
;
HEXA	CLRB				;HEXA    CLRB
	clrf	_Z			;        STAB 	Z
	call	TSTHEX			;        BSR  	TSTHEX
	skpnc				;        BCC  	SIZE
	bra	SIZE
	bsf	STATUS,C
HEX2	ROLA				;HEX2    ROLA
	ASLA				;        ASLA
	ASLA				;        ASLA
	ASLA				;        ASLA
	ASLA				;        ASLA
SHIFT	ROL	_Z			;SHIFT   ROL	Z
	ROLB				;        ROLB
	ASLA				;        ASLA
	skpz				;        BNE  	SHIFT
	bra	SHIFT
	INX				;        INX
 	call	TSTHEX			;        BSR  	TSTHEX
	skpc				;        BCS  	HEX2
	bra	HEX2-1
	LDAA	_Z			;        LDAA 	Z
	return				;        RTS
;
TSTHEX	call	TSTN			;TSTHEX  JSR	TSTN
	skpc				;        BCS  	HEX3
	bra	HEX3
	SUBAI	7			;        SUBA 	#7
	CMPAI	0x3A			;        CMPA 	#$3A
	bsf	STATUS,C		;        CLC
	btfsc	WREG,7			;        BLT  	HEX3
	bra	HEX3
	CMPAI	0x40			;        CMPA 	#$40
HEX3	return				;HEX3    RTS
;
CMPX	moviw	0[INDF0]		;CMPX    CMPB 	0,X
	subwf	Breg,W
	skpz				;        BNE  	L306
	bra	L306
	moviw	1[INDF0]		;        CMPA 	1,X
	subwf	Areg,W
L306	return				;L306    RTS
;
SRCH2	STX  	PX			;SRCH2   STX  	PX
	LDXI	TABLE4-2+0x8000		;        LDX  	#TABLE4-2
SEARCH	STS  	SP			;SEARCH  STS  	SP
S0	LDS  	PX			;S0      LDS  	PX
	DES				;        DES
	INX				;        INX
S1	INX				;S1      INX
S2	PULA				;S2	 PULA
	CMPAI	0x20			;        CMPA 	#$20
	skpnz				;        BEQ  	S2
	bra	S2
	TAB				;        TAB
        moviw	0[INDF0]		;	 SUBA 	0,X
	subwf	Areg,F
	ASLA				;        ASLA
        skpz				;	 BNE  	S5
	bra	S5
        skpc				;	 BCC  	S1
	bra	S1
	INX				;        INX
S4	INS				;S4	 INS
S3	STS  	PX			;S3      STS  	PX
	LDS  	SP			;        LDS  	SP
        return				;	 RTS
;
S5	moviw	INDF0++			;S5      LDAA 	0,X
	movwf	Areg			;        INX
        btfss	Areg,7			;	 BPL  	S5
	bra	S5
	CMPBI	'.'			;	 CMPB	#'.
	skpnz				;	 BEQ	S4
	bra	S4
        COMA				;	 COMA
        skpz				;	 BNE  	S0
	bra	S0
        bra	S3			;	 BRA  	S3
;
PRINT	call	SKB			;PRINT   BSR  	SKB9
	skpnz				;        BEQ  	PR9
	goto	NWLINE
PPR3	call	RQUOTE			;PR3	 BSR  	RQUOTE
	skpnz				;        BEQ  	PR4
	bra	PPR4
	STX  	PX			;	 STX  	PX
	LDXI	TABLE5-2+0x8000		;        LDX  	#TABLE5-2
	call	OPRATE			;        JSR  	OPRATE
PPR4	call	SKB			;PR4     BSR  	SKB9
	skpnz				;        BEQ  	PR9
	goto	NWLINE
	CMPAI	';'			;        CMPA 	#';
	skpnz				;        BEQ  	PR5
	bra	PPR5
	CMPAI	','			;        CMPA 	#',
	skpz				;        BNE  	ERR130
	bra	ERR130
	call	PT			;        BSR  	PT
PPR5	INX				;PR5     INX
PPR6	call	SKB			;PR6	 BSR  	SKB9
	skpz				;        BNE  	PR3
	bra	PPR3
	return				;        RTS
;
;SKB9	goto	SKB			;SKB9    JMP  	SKB
;
;PPR9	goto	NWLINE			;PR9     JMP  	NWLINE
;
L35F	call	OUTS			;L35F    JSR  	OUTS
PT	LDAA 	CHCNT			;PT    	 LDAA 	CHCNT
        BITAI	7			;	 BITA 	#7
        skpz				;	 BNE  	L35F
	bra	L35F
        return				;	 RTS
;
CHR	call	FACTPP			;CHR	 BSR  	FACTPP
OUT7	goto	_OUT			;OUT7    JMP  	OUT
;
_TAB	call	FACTPP			;TAB	 BSR  	FACTPP
	TAB				;        TAB
	call	TAB2			;        BRA  	TAB2
;
L373	call	OUTS			;L373    JSR  	OUTS
TAB2	incf 	CHCNT,W			;TAB2    CMPB 	CHCNT
	subwf	Breg,W
	skpnz				;        BHI  	L373
	bcf	STATUS,C
	skpnc
	bra	L373
	return				;        RTS
;
RQUOTE	call	SKB			;RQUOTE	 BSR  	SKB9
	CMPAI	'"'			;        CMPA 	#'"
	skpnz				;        BEQ  	L385
	bra	L385
	CMPAI	"'"			;        CMPA 	#''
	skpz				;        BNE  	PQ5
	bra	PQ5
L385	TAB				;L385    TAB
	INX				;        INX
	bra	L38B			;        BRA  	L38B
;
PQ4	call	_OUT			;PQ4     BSR  	OUT7
L38B	moviw	0[INDF0]		;L38B    LDAA 	0,X
	movwf	Areg
	skpnz				;        BEQ  	ERR130
	bra	ERR130
	INX				;        INX
	CBA				;        CBA
	skpz				;        BNE  	PQ4
	bra	PQ4
PQ5	return				;PQ5    	RTS
;
FACTPP	call	FACT9			;FACTPP  JSR  	FACT9
        goto	POP			;	 JMP  	POP
;
ERR130	LDABI	130			;ERR130  LDAB 	#130
        bra	L3A0			;	 BRA  	L3A0
;
ERR140  LDABI	140			;ERR140	 LDAB 	#140
L3A0	goto	ERRMSG			;L3A0    JMP  	ERRMSG
;
DIVIDE	moviw	0[INDF0]		;DIVIDE	 LDAA 	0,X
	movwf	Areg
	moviw	1[INDF0]		;        ORAA 	1,X
	iorwf	Areg,F
	skpnz				;        BEQ  	ERR140
	bra	ERR140
	call	SSETCNT			;        BSR  	SETCNT
	call	ROL2X			;        BSR  	ROL2X
	ROLA				;        ROLA
	NEGA				;        NEGA
	TAB				;        TAB
	call	CHECK			;        BSR  	CHECK
	ROLA				;        ROLA
	EORAI	1			;        EORA 	#1
	RORA				;        RORA
	call	DIV3			;        BSR  	DIV3
	call	CMPX			;        JSR  	CMPX
	skpz				;        BNE  	RDIV
	bra	RDIV
	CLRA				;        CLRA
	TAB				;        TAB
	moviw	3[INDF0]		;        INC  	3,X
	incf	WREG,F
	movwi	3[INDF0]
	skpz				;        BNE  	RDIV
	bra	RDIV
	moviw	2[INDF0]		;        INC  	2,X
	incf	WREG,F
	movwi	2[INDF0]
RDIV	addfsr	FSR0,2			;RDIV    INX
					;        INX
	return				;        RTS
;
BINDIV	call	SSETCNT			;BINDIV  BSR  	SETCNT
DIV2	call	ROL2X			;DIV2    BSR  	ROL2X
	rlf	Areg,F			;        ROLA
	rlf	Breg,F			;        ROLB
	moviw	1[INDF0]		;        SUBA 	1,X
	subwf	Areg,F
	moviw	0[INDF0]		;        SBCB 	0,X
	subwfb	Breg,F
	call	CHECK			;        BSR  	CHECK
DIV3	decfsz	_F,F			;DIV3    DEC  	F
	bra	DIV2			;        BNE  	DIV2
ROL2X	moviw	3[INDF0]		;ROL2X   ROL  	3,X
	rlf	WREG,F
	movwi	3[INDF0]
	moviw	2[INDF0]		;        ROL  	2,X
	rlf	WREG,F
	movwi	2[INDF0]
	return				;        RTS
;
CHECK	moviw	0[INDF0]		;CHECK   PSHB
	xorwf	Breg,W			;	 EORB 	0,X
					;	 PULB
	bsf	STATUS,C		;        SEC
        btfss	WREG,7			;	 BPL  	L3EA
	bra	L3EA
	moviw	1[INDF0]		;        ADDA 	1,X
	addwf	Areg,F
        moviw	0[INDF0]		;	 ADCB 	0,X
	addwfc	Breg,F
	bcf	STATUS,C		;        CLC
L3EA    return				;L3EA	 RTS
;
SSETCNT	movlw	.16			;SETCNT  LDAA 	#16
	movwf	_F			;        STAA 	F
	clrf	Areg			;        CLRA
	clrf	Breg			;        TAB
	return				;        RTS
;
MULT	call	SSETCNT			;MULT    BSR  	SETCNT
MLT2	ASLA				;MLT2    ASLA
	ROLB				;        ROLB
	moviw	1[INDF0]		;        ROL  	1,X
	rlf	WREG,F
	movwi	1[INDF0]
	moviw	0[INDF0]		;        ROL  	0,X
	rlf	WREG,F
	movwi	0[INDF0]
	skpc				;        BCC  	L400
	bra	L400
	moviw	3[INDF0]		;        ADDA 	3,X
	addwf	Areg,F
	moviw	2[INDF0]		;        ADCB 	2,X
	addwfc	Breg,F
L400	decfsz	_F,F			;L400    DEC  	F
	bra	MLT2			;        BNE  	MLT2
	addfsr	FSR0,2			;        INX
					;        INX
	goto	STAX			;        JMP  	STAX
;
PNUM	moviw	0[INDF0]		;PNUM    LDX  	0,X
	movwf	_W			;        STX  	W
	moviw	1[INDF0]
	movwf	_W+1
        LDXI	_W			;	 LDX  	#W
        call	ABSX			;	 BSR  	ABSX
        skpc				;	 BCC  	PN2
	bra	PN2
        LDAAI	'-'			;	 LDAA 	#'-
        call	_OUT			;	 BSR  	OUT
PN2	addfsr	FSR0,-2			;PN2     DEX
        movlw	.10			;	 DEX
        movwf	Breg			;	 LDAB 	#10
        movwi	1[INDF0]		;	 STAB 	1,X
        clrw				;	 CLR  	0,X
	movwi	0[INDF0]
        ASRB				;	 ASRB
PN3	PSHB				;PN3   	 PSHB
        call	BINDIV			;	 BSR  	BINDIV
        PULB				;	 PULB
        PSHA				;	 PSHA
        decfsz	Breg,F			;	 DECB
	bra	PN3			;	 BNE  	PN3
	LDXI	BUFFER			;	 LDX  	#BUFFER
	LDABI	4			;	 LDAB 	#4
PN4	PULA				;PN4     LDAA 	F
        movf	_F,F			;	 PULA
	skpz				;	 BNE  	 PN5
	bra	PN5
	STAA 	_F			;        STAA 	F
        skpz				;	 BEQ  	L43A
PN5	call	PN6			;PN5     BSR  	PN6
L43A	decfsz	Breg,F			;L43A    DECB
        bra	PN4			;	 BNE  	PN4
        PULA				;	 PULA
PN6	ADDAI	0x30			;PN6     ADDA 	#$30
        TST	AFLG			;	 TST  	AFLG
        skpnz				;	 BEQ  	OUT
	bra	_OUT
	movf	Areg,W			;        STAA 	0,X
	movwi	INDF0++			;        INX
_OUT	incf	CHCNT,F			;OUT     INC  	CHCNT
        call	BREAK			;	 JSR  	BREAK
        goto	OUTFFF			;	 JMP  	OUTEEE
;
ABSX	moviw	0[INDF0]		;ABSX    TST  	0,X
	bcf	STATUS,C		;;carry clr
        btfss	WREG,7			;	 BPL  	RABS
	bra	RABS
NEGX	moviw	1[INDF0]		;NEGX    NEG  	1,X
	comf	WREG,F
	incf	WREG,F
	movwi	1[INDF0]
        skpz				;	 BNE  	L45B
	bra	L45B
        moviw	0[INDF0]		;	 DEC  	0,X
	decf	WREG,F
	movwi	0[INDF0]
L45B	moviw	0[INDF0]		;L45B    COM  	0,X
	comf	WREG,F
	movwi	0[INDF0]
	bsf	STATUS,C		;;carry set
RABS	return				;RABS    RTS
;
SKB2	INX				;SKB2    INX
SKB	moviw	0[INDF0]		;SKB	 LDAA 	0,X
	movwf	Areg
        CMPAI	0x20			;	 CMPA 	#$20
        skpnz				;	 BEQ  	SKB2
	bra	SKB2
        TSTA				;	 TSTA
	bcf	STATUS,C		;;carry clr
        skpnz				;	 BEQ  	L468
	bra	L468
        CMPAI	':'			;	 CMPA 	#':
	SEC				;        SEC
L468	return				;L468    RTS
;
EXPR3	call	SKB			;EXPR3   BSR  	SKB
	CMPAI	'-'			;        CMPA 	#'-
	skpz				;        BNE  	E3
	bra	E3
	call	E9			;        BSR  	E9
	bra	E5			;        BRA  	E5
;
E3	CMPAI	'+'			;E3    	 CMPA 	#'+
	skpz				;        BEQ  	E4
	DEX				;        DEX
E4	call	TERM2			;E4	 BSR	TERM2
E5	LDX  	PX			;E5	 LDX  	PX
	call	SKB			;        BSR  	SKB
	CMPAI	'+'			;        CMPA 	#'+
	skpz				;        BNE  	E6
	bra	E6
	call	TERM2			;        BSR  	TERM2
E55	call	ADD			;E55	 BSR  	ADD
	bra	E5			;        BRA  	E5
;
E6	CMPAI	'-'			;E6	 CMPA 	#'-
	skpz				;        BNE  	E7
	bra	E7
	call	E9			;        BSR  	E9
	bra	E55			;        BRA  	E55
;
E9	call	TERM2			;E9	 BSR	TERM2
	bra	NEGX			;        BRA	NEGX
;
ADD	call	POP			;ADD	 JSR	POP
	addfsr	FSR0,2			;        INX
					;        INX
_ADD3	moviw	1[INDF0]		;ADD3    ADDA 	1,X
	addwf	Areg,F			;	 ADCB 	0,X
        moviw	0[INDF0]
	addwfc	Breg,F
STAX	movf	Areg,W			;STAX    STAA 	1,X
	movwi	1[INDF0]		;        STAB 	0,X
	movf	Breg,W
	movwi	0[INDF0]
E7	return				;E7	 RTS
;
ABS	call	FACT9			;ABS	 JSR  	FACT9
	call	SAVE			;        BSR  	SAVE
	call	ABSX			;        BSR  	ABSX
	LDX  	PX			;	 LDX  	PX
	return				;        RTS
;
TSTEQ	call	SKB			;TSTEQ   BSR  	SKB
        CMPAI	'='			;	 CMPA 	#'=
        skpz				;	 BNE  	R5
	bra	R5
        addfsr	FSR1,2			;	 INS
        				;	 INS
        INCB				;	 INCB
        bra	R3			;	 BRA  	R3
;
REL	CLRB				;REL	 CLRB
	call	TSTEQ			;        BSR  	TSTEQ
        call	R7			;	 BSR  	R7
        skpz				;	 BNE  	R6
	bra	R6
        call	TSTEQ			;	 BSR  	TSTEQ
R2	CMPAI	'>'			;R2	 CMPA 	#'>
        skpz				;	 BNE  	R5
	bra	R5
R3	INCB				;R3    	 INCB
R4	INX				;R4    	 INX
        CLRA				;	 CLRA
R5	return				;R5    	 RTS
;
R6	call	R2			;R6      BSR  	R2
        skpz				;	 BNE  	R5
	bra	R5
        call	TSTEQ			;	 BSR  	TSTEQ
R7	CMPAI	'<'			;R7      CMPA 	#'<
        skpz				;	 BNE  	R5
	bra	R5
        ADDBI	4			;	 ADDB 	#4
        bra	R4			;	 BRA  	R4
;
TERM2	call	TERM			;TERM2   BSR  	TERM
SAVE	STX  	PX			;SAVE	 STX  	PX
	LDX  	EXSP			;	 LDX  	EXSP
        return				;	 RTS
;
EXPR	call	PSHSP			;EXPR    BSR  	EXPR3
	call	EXPR3
        call	REL			;	 BSR  	REL
	call	POPSP
        TSTB				;	 TSTB
        skpnz				;	 BEQ  	R5
	bra	R5
	PSHB				;   	 PSHB
        call	PSHSP			;	 BSR  	EXPR3
        call	EXPR3
        call	POP			;	 JSR  	POP
	call	POPSP
	LDX  	EXSP			;	 LDX  	EXSP
        moviw	1[INDF0]		;	 SUBA 	1,X
        subwf	Areg,F
	moviw	0[INDF0]		;	 SBCB 	0,X
        subwfb	Breg,W
	movwf	Temp
        PULB				;	 PULB
	movf	Temp,W
        skpnz
        bra	L4F8
	btfsc	Temp,7
	bra	LT			;	 BLT  	LT
	bra	GT			;	 BGT  	GT
L4F8	iorwf	Areg,W			;	 TSTA
	skpnz				;	 BEQ  	EQ
	bra	EQ
GT	ASRB				;GT    	 ASRB
EQ	ASRB				;EQ    	 ASRB
LT	ANDBI	1			;LT    	 ANDB 	#1
        movf	Breg,W			;	 STAB 	1,X
	movwi	1[INDF0]
        clrw				;	 CLR  	0,X
	movwi	0[INDF0]
	LDX	_Z			;        LDX  	Z
        return				;	 RTS
;
GETN	call	TSTN			;GETN    BSR  	TSTN
        skpnc				;	 BCC  	NOTN
	bra	NOTN
        CLRB				;	 CLRB
        STAB	_Z+1			;	 STAB 	Z+1
GN2	STAB	_Z			;GN2	 STAB 	Z
        movlw	0x0F			;	 ANDA 	#$0F
	andwf 	Areg,W			;        STAA 	F
	movwf 	_F
        LDAA	_Z+1			;	 LDAA 	Z+1
        ASLA				;	 ASLA
        ROLB				;	 ROLB
        ASLA				;	 ASLA
        ROLB				;	 ROLB
        ADDA	_Z+1			;	 ADDA 	Z+1
        ADCB	_Z			;	 ADCB 	Z
        ASLA				;	 ASLA
        ROLB				;	 ROLB
        ADDA	_F			;	 ADDA 	F
        STAA	_Z+1			;	 STAA 	Z+1
        ADCBI	0			;	 ADCB 	#0
	INX				;    	 INX
        call	TSTN			;	 BSR  	TSTN
        skpc				;	 BCS  	GN2
	bra	GN2
        LDAA	_Z+1			;	 LDAA 	Z+1
	bcf	STATUS,C		;        SEC
NOTN	return				;NOTN    RTS
;
TSTN	call	SKB			;TSTN    JSR  	SKB8
	CMPAI	'0'			;        CMPA 	#'0
	bsf	STATUS,C		;        CLC
	btfsc	WREG,7			;        BLT  	T3
	bra	T3
	CMPAI	0x3A			;        CMPA 	#$3A
T3	return				;T3	 RTS
;
TERM	call	FACT			;TERM    BSR  	FACT
T1	call	SKB			;T1    	 BSR  	SKB8
        CMPAI	'*'			;	 CMPA 	#'*
        skpz				;	 BNE  	T2
	bra	T2
        call	FACT2			;	 BSR  	FACT2
        call	MULT			;	 JSR  	MULT
T11	STX  	EXSP			;T11     STX  	EXSP
	LDX  	PX			;	 LDX  	PX
        bra	T1			;	 BRA  	T1
;
T2	CMPAI	'/'			;T2      CMPA 	#'/
        skpz				;	 BNE  	T3
	bra	T3
        call	FACT2			;	 BSR  	FACT2
        call	DIVIDE			;	 JSR  	DIVIDE
        bra	T11			;	 BRA  	T11
;
FACT2	call	FACT			;FACT2   BSR  	FACT
	goto	SAVE			;        JMP  	SAVE
;
HEXA2	INX				;HEXA2 	 INX
        call	HEXA			;	 JSR  	HEXA
        bra	PUSH			;	 BRA  	PUSH
;
PEEK	call	FACT			;PEEK    BSR  	FACT
        call	POP			;	 JSR  	POP
        call	TAX			;	 BSR  	TAX
	moviw	0[INDF0]		;	 LDAA 	0,X
	movwf	Areg
        CLRB				;	 CLRB
	bra	L592			;        BRA  	L592
;
FACT	INX				;FACT 	 INX
        call	GETN			;	 BSR  	GETN
        skpc				;	 BCS  	PUSH
	bra	PUSH
	CMPAI	'#'			;        CMPA 	#'#
        skpnz				;	 BEQ  	PEEK
	bra	PEEK
	CMPAI	'$'			;        CMPA 	#'$
        skpnz				;        BEQ  	HEXA2
	bra	HEXA2
	STX  	PX			;	 STX  	PX
	LDXI	TABLE3-2+0x8000		;        LDX  	#TABLE3-2
OPRATE	call	SEARCH			;OPRATE	 JSR  	SEARCH
	banksel	STKPTR
	incf	STKPTR,F
        moviw	1[INDF0]        	;	 LDAA 	1,X
	movwf	TOSL			;	 PSHA
        moviw	0[INDF0]        	;	 LDAA 	0,X
        movwf	TOSH			;	 PSHA
	movwf	Areg
	movlb	.0
	LDX  	PX			;	 LDX  	PX
        return				;	 RTS
;
FVAR	call	TAX			;FVAR    BSR  	TAX
        moviw	1[INDF0]        	;	 LDAA 	1,X
	movwf	Areg
        moviw	0[INDF0]        	;        LDAB 	0,X
	movwf	Breg
L592	LDX  	PX			;L592	 LDX  	PX
PUSH	STX	_Z			;PUSH	 STX  	Z
	LDX  	EXSP			;	 LDX  	EXSP
	addfsr	FSR0,-2        		;	 DEX
        				;	 DEX
	CPX  	BUFEND			;        CPX  	BUFEND
	skpnz				;        BLE  	ERR150
	bra	ERR150
	btfsc	WREG,7
	bra	ERR150
PUSH2	call	STAX			;PUSH2   JSR  	STAX
PUSH3	STX  	EXSP			;PUSH3   STX  	EXSP
	LDX	_Z			;        LDX  	Z
        return				;	 RTS
;
ERR150	LDABI	150			;ERR150	 LDAB 	#150
ER	goto	ERRMSG			;ER	 JMP	ERRMSG
;
ERR160	LDABI	160			;ERR160	 LDAB	#160
        bra	ER			;	 BRA  	ER
;
ERR170	LDABI	170			;ERR170	 LDAB 	#170
        bra	ER			;        BRA  	ER
;
;SKB8	goto	SKB			;SKB8    JMP  	SKB
;
NOTFNC	call	TSTV			;NOTFNC	 BSR  	TSTV
	skpc				;        BCC  	FVAR
	bra	FVAR
        moviw	0[INDF0]        	;	 LDAA 	0,X
	movwf	Areg
	CMPAI	'('			;        CMPA 	#'(
	skpz				;        BNE  	ERR160
	bra	ERR160
	INX				; 	 INX
FACT9	call	EXPR			;FACT9   JSR  	EXPR
L5C4	call	SKB			;L5C4	 BSR	SKB8
	CMPAI	')'			;        CMPA 	#')
	skpz				;        BNE  	ERR160
	bra	ERR160
	INX				; 	 INX
	return				;        RTS
;
TAX	STX  	PX			;TAX	 STX  	PX
	movf	Areg,W			;        STAA 	Z+1
	movwf	_Z+1			;        STAB 	Z
	movwf	FSR0L			;        LDX  	Z
	movf	Breg,W
	movwf	_Z
	movwf	FSR0H
	return				;        RTS
;
MOD	call	EXPR			;MOD     JSR  	EXPR
        moviw	0[INDF0]        	;	 LDAA 	0,X
	movwf	Areg
	CMPAI	','			;        CMPA 	#',
	skpz				;        BNE  	ERR170
	bra	ERR170
	INX				; 	 INX
MOD2	call	FACT9			;MOD2    BSR  	FACT9
	STX  	_Z			;	 STX  	Z
	LDX  	EXSP			;	 LDX  	EXSP
	call	DIVIDE			;        JSR  	DIVIDE
	bra	PUSH2			;        BRA  	PUSH2
;
RANDOM	LDAA 	RND+1			;RANDOM	 LDAA 	RND+1
	LDAB 	RND			;        LDAB 	RND
	ADDB 	RND+1			;        ADDB 	RND+1
	ADCAI	0x95			;        ADCA 	#$95
	ADCBI	0xAB			;        ADCB 	#$AB
	STAB 	RND+1			;        STAB 	RND+1
	STAA 	RND			;        STAA 	RND
	call	PUSH			;        BSR  	PUSH
	bra	MOD2			;        BRA  	MOD2
;
USER					;USER	 BSR  	USER2
					;        BRA  	L592
;
USER2					;USER2   BSR  	ARG2
        				;	 PSHA
        				;	 PSHB
					;        BSR  	ARG
        				;	 PSHA
        				;	 PSHB
					;        BSR  	ARG
        				;	 PSHA
        				;	 PSHB
					;	 TPA
        				;	 PSHA
					;        BSR  	L5C4
					;	 STX  	PX
					;        RTI
;
ARG     			       	;ARG	 LDAA 	0,X
					;        CMPA 	#',
					;        BNE  	NONE
					; 	 INX
ARG2					;ARG2    JMP  	EXPRPP
;
NONE	CLRA				;NONE    CLRA
	CLRB				;        CLRB
	return				;        RTS
;
TSTV	call	SKB			;TSTV    BSR  	SKB8
	CMPAI	0x40			;        CMPA 	#$40
	skpnz				;        BEQ  	ARRAY
	bra	ARRAY
	CMPAI	'A'			;        CMPA 	#'A
	skpc				;        BCS  	NOTV
	bra	NOTV
	CMPAI	'Z'+1			;        CMPA 	#'Z
	btfss	WREG,7			;        BHI  	NOTV
	bra	NOTV
	movlw	0x25			;;AtoZ
	subwf	Areg,F
        ASLA				;	 ASLA
	CLRB				;        CLRB
	INX				; 	 INX
	return				;        RTS
;
ARRAY	call	FACT			;ARRAY   JSR  	FACT
	call	POP			;        JSR  	POP
	BITBI	0xC0			;        BITB 	#$C0
	skpz				;        BNE  	ERR11
	goto	ERR110
	SEC				;        SEC
	ROLA				;        ROLA
        ROLB				;	 ROLB
	movf 	PREND+1,W		;        ADDA 	PREND+1
	movf	LDFLG,F			;++
	skpz				;++
	movlw	LOW(UMTOP)		;++
	addwf	Areg,F
	movf	PREND,W			;        ADCB 	PREND
	movf	LDFLG,F			;++
	skpz				;++
	movlw	HIGH(UMTOP)		;++
	addwfc	Breg,F
	CMPBI 	HIGH(UMBTM)		;        CMPB 	RAMEND
	skpz				;        BNE  	L649
	bra	L649
	CMPAI 	LOW(UMBTM)		;        CMPA 	RAMEND+1
L649	skpnc				;L649	 BCC  	ERR11
	goto	ERR110
	CLC				;        CLC
	return				;        RTS
;
;ERR11	goto	ERR110			;ERR11   JMP  	ERR110
;
NOTV	SEC				;NOTV    SEC
	return				;        RTS
;
;TSTEQ2	call	TSTEQ			;TSTEQ2  JSR  	TSTEQ
ERR180	LDABI	180			;ERR180  LDAB 	#180
ERR19	goto	ERRMSG			;ERR19   JMP  	ERRMSG
;
LET3	call	TSTV			;LET3    JSR  	TSTV
	skpnc				;        BCS  	ERR180
	bra	ERR180
LET4	STAA 	_W+1			;LET4    STAA 	W+1
	STAB 	_W			;        STAB 	W
	addfsr	FSR1,-2			;        BSR  	TSTEQ2
	call	TSTEQ
	call	EXPRPP			;        BSR  	EXPRPP
	STX  	PX			;	 STX  	PX
	LDX	_W			;        LDX  	W
	return				;        RTS
;
ERR190	LDABI	190			;ERR190  LDAB 	#190
        bra	ERR19			;	 BRA  	ERR19
;
THEN	CLRB				;THEN	 CLRB
        PSHB				;	 PSHB
	call	GETN			;        JSR  	GETN
	skpc				;        BCS  	GOTO2
	bra	GOTO2
	goto	STMT3			;        JMP  	STMT3
;
POKE	call	FACT			;POKE    JSR  	FACT
        call	POP			;	 BSR  	POP
        call	LET4			;	 BSR  	LET4
	TAB				;        TAB
        bra	LET2			;	 BRA  	LET2
;
PSX	STS  	SP			;PSX     STS  	SP
        TXS				;	 TXS
	LDX  	SUBSP			;        LDX  	SUBSP
	CPXI  	SUBBTM			;        CPX  	#SUBBTM
	skpnz				;	 BEQ  	ERR190
	bra	ERR190
	addfsr	FSR0,-2        		;	 DEX
        				;	 DEX
	movf	FSR1H,W			;        STS  	0,X
	movwi	0[INDF0]
	movf	FSR1L,W
	movwi	1[INDF0]
RESTR	STX  	SUBSP			;RESTR	 STX  	SUBSP
        TSX				;	 TSX
	LDS  	SP			;        LDS  	SP
	return				;        RTS
;
PLX	LDX  	SUBSP			;PLX     LDX  	SUBSP
	CPXI  	SUBSTK			;        CPX  	#SUBSTK
	skpnz				;        BEQ  	ERR190
	bra	ERR190
	STS  	SP			;        STS  	SP
	moviw	INDF0++			;        LDS  	0,X
	movwf	FSR1H			;        INX
	moviw	INDF0++			;        INX
	movwf	FSR1L
        bra	RESTR			;        BRA  	RESTR
;
EXPRPP	call	EXPR7			;EXPRPP  BSR  	EXPR7
POP	STX  	_Z			;POP	 STX  	Z
	LDX  	EXSP			;	 LDX  	EXSP
	CPXI  	EXSTK			;        CPX  	#EXSTK
	skpnz				;	 BEQ  	ERR180
	bra	ERR180
        moviw	INDF0++	        	;	 LDAA 	1,X
	movwf	Breg	        	;        LDAB 	0,X
        moviw	INDF0++			;        INX
	movwf	Areg			;        INX
	STX  	EXSP			;        STX  	EXSP
	LDX	_Z			;        LDX  	Z
        return				;	 RTS
EXPR9	LDX  	PX			;EXPR9	 LDX  	PX
EXPR7	goto	EXPR			;EXPR7   JMP  	EXPR
;
_GOTO	CLRA				;GOTO    CLRA
GOSUB   PSHA				;GOSUB	 PSHA
        call	EXPRPP			;	 BSR	EXPRPP
GOTO2	call	SETLN			;GOTO2	 JSR  	SETLN
        PULA				;	 PULA
        TSTA				;	 TSTA
        skpz				;	 BEQ  	L6CF
        call	PSX			;	 BSR  	PSX
L6CF	call	FINDER			;L6CF    JSR  	FINDER
        skpnc				;	 BCC  	L6D8
	goto	STMT
ERR200	LDABI	200			;ERR200	 LDAB 	#200
        bra	ERR22			;	 BRA  	ERR22
;
;L6D8	goto	STMT			;L6D8    JMP  	STMT
;
LET	call	SKB			;LET	 JSR  	SKB
	CMPAI	'#'			;        CMPA 	#'#
	skpnz				;        BEQ  	POKE
	bra	POKE
LET1	call	LET3			;LET1    JSR  	LET3
	movf	Areg,W			;        STAA 	1,X
	movwi	1[INDF0]
LET2	movf	Breg,W			;LET2    STAB 	0,X
	movwi	0[INDF0]
	LDX  	PX			;	 LDX  	PX
	return				;        RTS
;
FOR	call	LET1			;FOR     BSR  	LET1
	LDAA 	_W+1			;        LDAA 	W+1
	LDAB 	_W			;        LDAB 	W
	call	PUSH			;        JSR  	PUSH
	call	SRCH2			;        JSR  	SRCH2
	CPXI  	TOMSG+0x8000		;        CPX  	#TOMSG
	skpz				;        BNE  	ERR210
	bra	ERR210
	call	EXPR9			;        BSR  	EXPR9
	call	SRCH2			;        JSR  	SRCH2
	CPXI  	STPMSG+0x8000		;        CPX  	#STPMSG
	skpnz				;        BEQ  	FOR1
	bra	FOR1
	LDAAI	1			;        LDAA 	#1
	CLRB				;        CLRB
	call	L592			;        JSR  	L592
	bra	L711			;        BRA  	L711
;
FOR1	call	EXPR9			;FOR1    BSR  	EXPR9
L711	movf  	FSR0L,W			;L711	 STX  	PX
	movwf 	PX+1			;	 LDAA 	PX+1
	movwf 	Areg			;	 LDAB 	PX
	movf  	FSR0H,W
	movwf 	PX
	movwf 	Breg
        call	PUSH			;	 JSR  	PUSH
        LDAA 	_W+1			;	 LDAA 	W+1
        LDAB 	_W			;	 LDAB 	W
	LDX  	FORSP			;	 LDX  	FORSP
FOR3	call	TST2			;FOR3	 BSR	TST2
	skpnc				;	 BCC	FOR4
	bra	FOR4
	LDX  	FORSP			;	 LDX  	FORSP
	CPXI  	FORSTK-64		;        CPX  	#FORSTK-64
	skpz				;	 BNE  	L732
	bra	L732
ERR210	LDABI	210			;ERR210  LDAB 	#210
ERR22	goto	ERRMSG			;ERR22   JMP  	ERRMSG
;
FOR4	addfsr	FSR0,8			;FOR4    BSR  	INX8
L732	call	FORPSH			;L732    BSR  	FORPSH
        bra	NEXT5			;	 BRA  	NEXT5
;
TSTSTK	call	CMPX			;TSTSTK  JSR  	CMPX
	skpnz				;        BEQ  	TST3
	goto	TST3
	addfsr	FSR0,8			;        BSR  	INX8
TST2	CPXI  	FORSTK			;TST2    CPX  	#FORSTK
	skpz				;	 BNE  	TSTSTK
	bra	TSTSTK
        bcf	STATUS,C		;	 SEC
TST3	return				;TST3    RTS
;
FORPSH	call	L746			;FORPSH  BSR  	L746
L746	call	L748			;L746    BSR  	L748
L748	call	POP			;L748    JSR  	POP
	addfsr	FSR0,-2        		;	 DEX
        				;	 DEX
STAX2	goto	STAX			;STAX2	 JMP  	STAX
;
ERR220	LDABI	220			;ERR220	 LDAB 	#220
        bra	ERR22			;	 BRA  	ERR22
;
NEXT	call	TSTV			;NEXT	 JSR  	TSTV
	STX  	PX			;	 STX  	PX
	LDX  	FORSP			;	 LDX  	FORSP
        skpc				;	 BCC  	L761
	bra	L761
        moviw	1[INDF0]        	;	 LDAA 	1,X
	movwf	Areg
        moviw	0[INDF0]        	;        LDAB 	0,X
	movwf	Breg
L761	call	TST2			;L761    BSR  	TST2
        skpc				;	 BCS  	ERR220
	bra	ERR220
	STX  	FORSP			;	 STX  	FORSP
        moviw	5[INDF0]        	;	 LDAA 	5,X
	movwf	Areg
        moviw	4[INDF0]        	;	 LDAB 	4,X
	movwf	Breg
        moviw	0[INDF0]		;	 LDX  	0,X
	movwf	Temp
	moviw	1[INDF0]
	movwf	FSR0L
	movf	Temp,W
	movwf	FSR0H
        call	_ADD3			;	 JSR  	ADD3
	LDX  	FORSP			;	 LDX  	FORSP
        moviw	2[INDF0]		;	 CMPB 	2,X
	subwf	Breg,W
        skpz				;	 SEC
       	bra	NEXT4			;	 BLT  	NEXT4
					;        CLC
        				;	 BGT  	NEXT4
L77A    moviw	3[INDF0]		;	 CMPA 	3,X
	subwf	Areg,W
        skpnz				;	 BEQ  	AGAIN
	bra	AGAIN
NEXT4	comf	Areg,F			;NEXT4   RORA
	rrf	Areg,F
	comf	Areg,F
        moviw	4[INDF0]		;	 EORA 	4,X
	xorwf	Areg,F
        btfsc	Areg,7			;	 BMI  	AGAIN
	bra	AGAIN
        addfsr	FSR0,8			;	 BSR  	INX8
NEXT5	STX  	FORSP			;NEXT5	 STX  	FORSP
	LDX  	PX			;	 LDX  	PX
        return				;	 RTS
;
					;INX8    BSR  	L78C
					;L78C    INX
					;        INX
					;        INX
					;        INX
					;        RTS
;
AGAIN   moviw	6[INDF0]		;AGAIN	 LDX  	6,X
	movwf	Temp
	moviw	7[INDF0]
	movwf	FSR0L
	movf	Temp,W
	movwf	FSR0H
        return				;	 RTS
;
INPUT	movf	FSR0L,W			;INPUT	 STX  	W
	movwf	_W+1
	movf	FSR0H,W
	movwf	_W
	movwf	Areg			;        LDAA 	W
        skpnz				;	 BEQ  	ERR10
	goto	ERR100
	movf  	BUFEND,W		;	 LDX  	BUFEND
	movwf  	FSR0H			;	 STX  	V
	movwf  	V
	movf	BUFEND+1,W
	movwf	FSR0L
	movwf  	V+1
        LDX  	_W			;	 LDX  	W
        call	RQUOTE			;	 JSR  	RQUOTE
        skpnz				;	 BNE  	IN2
        call	TSTCM			;	 BSR  	TSTCM
IN2	call	TSTV			;IN2	 JSR  	TSTV
        skpnc				;	 BCS  	ERR10
	goto	ERR100
        PSHA				;	 PSHA
        PSHB				;	 PSHB
	STX  	_W			;	 STX  	W
        LDX  	V			;	 LDX  	V
        call	SKB			;	 BSR  	SKB1
        skpz				;	 BNE  	IN3
	bra	IN3
        LDAAI	'?'			;	 LDAA 	#'?
        call	OUT3			;	 BSR  	OUT3
        call	OUTS			;        BSR  	OUTS
        call	GL2			;        JSR  	GL2
IN3	call	EXPRPP			;IN3	 JSR  	EXPRPP
        call	TSTCM			;        BSR  	TSTCM
	STX  	V			;	 STX  	V
        TSX				;	 TSX
        moviw	0[INDF0]		;	 LDX  	0,X
	movwf	Temp
	moviw	1[INDF0]
	movwf	FSR0L
	movf	Temp,W
	movwf	FSR0H
        addfsr	FSR1,2			;	 INS
        				;	 INS
        call	STAX			;	 JSR  	STAX
        LDX  	_W			;	 LDX  	W
        call	SKB			;	 BSR  	SKB1
        skpnz				;	 BEQ  	IN4
	bra	IN4
        CMPAI	','			;	 CMPA 	#',
        skpz				;	 BNE  	ERR10
	goto	ERR100
	INX				; 	 INX
        bra	IN2			;	 BRA  	IN2
;
;ERR10	goto	ERR100			;ERR10	 JMP  	ERR100
;
TSTCM	call	TSTCM2			;TSTCM	 BSR  	TSTCM2
        skpz				;	 BNE  	IN4
	bra	IN4
	INX				; 	 INX
IN4    	return				;IN4	 RTS
;
TSTCM2  PSHA				;TSTCM2	 PSHA
	call	SKB			;        BSR  	SKB1
	movf	Areg,W
	movwf	Temp
	PULA				;        CMPA 	#',
        movlw	','			;	 PULA
	subwf	Temp,W
	return				;        RTS
;
;SKB1	goto	SKB			;SKB1    JMP  	SKB
;
OUTS	LDAAI	0x20			;OUTS    LDAA 	#$20
OUT3	goto	_OUT			;OUT3    JMP  	OUT
;
_LIST	CLRB				;LIST	 CLRB
	LDAAI	1			;        LDAA 	#1
        call	SETLN			;	 JSR  	SETLN
        LDABI	0x7F			;	 LDAB 	#$7F
        LDAAI	0xFF			;	 LDAA 	#$FF
        PSHA				;	 PSHA
        call	SKB			;	 BSR  	SKB1
	movf	Areg,W
	movwf	Temp
        PULA				;	 PULA
        movf	Temp,F			;	 BEQ  	LIST2
	skpnz
	bra	LIST2
        call	EXPRPP			;	 JSR  	EXPRPP
        call	SETLN			;	 JSR  	SETLN
        call	TSTCM2			;	 BSR  	TSTCM2
        skpz				;	 BNE  	LIST2
	bra	LIST2
	INX				; 	 INX
        call	EXPRPP			;	 JSR  	EXPRPP
LIST2	movf 	Areg,W			;LIST2   STAA 	SP+1
	movwf 	SP+1			;	 STAB 	SP
	movwf  	FSR0L			;        LDX  	SP
	movf 	Breg,W
	movwf 	SP
	movwf  	FSR0H
        iorwf	Areg,W			;	 BGT  	L81E
	skpnz
	bra	L819
	btfss	Breg,7
	bra	L81E
L819	movlw	0xFF			;L819    LDX  	#32767
	movwf  	FSR0L       		;	 STX  	SP
	movwf 	SP+1
	movlw	0x7F
	movwf  	FSR0H
	movwf 	SP
L81E	call	LNFD			;L81E    JSR  	LNFD
        bra	L825			;	 BRA  	L825
;
LIST3	call	LISTX			;LIST3   BSR  	LISTX
L825	LDAA 	SP+1			;L825    LDAA 	SP+1
        LDAB 	SP			;	 LDAB 	SP
        call	CMPX			;	 JSR  	CMPX
        skpnc				;	 BCC  	LIST3
	bra	LIST3
        LDAAI	3			;	 LDAA 	#3
        call	OUT3			;	 BSR  	OUT3
C9	goto	CONTRL			;C9	 JMP  	CONTRL
;
LISTX	LDAAI	2			;LISTX   LDAA 	#2
	call	OUT3			;        BSR  	OUT3
	call	PNUM9			;        BSR  	PNUM9
	INX				; 	 INX
	LDAAI	0x20			;        LDAA 	#$20
	call	PD2			;        BSR  	PD2
NWLINE	STX  	_Z			;NWLINE	 STX  	Z
	LDXI	CRLF+0x8000		;        LDX  	#CRLF
	call	PD			;        BSR  	PD
	clrf	CHCNT			;        CLR  	CHCNT
LX2	LDX  	_Z			;LX2     LDX  	Z
	return				;        RTS
;
PNUM9	STX  	_Z			;PNUM9	 STX  	Z
L84F	call	PNUM			;L84F	 JSR  	PNUM
        bra	LX2			;	 BRA  	LX2
;
PD2	call	OUT3			;PD2	 BSR  	OUT3
	INX				; 	 INX
PD	moviw	0[INDF0]		;PD	 LDAA 	0,X
	movwf	Areg
	skpz				;        BNE  	PD2
	bra	PD2
	INX				; 	 INX
	return				;        RTS
;
ERRMSG	LDSI  	STACK			;ERRMSG	 LDS  	#STACK
	banksel	STKPTR			;++
	clrf	STKPTR			;++
	movlb	.0			;++
        call	NWLINE			;	 BSR  	NWLINE
	LDXI	ERR+0x8000		;        LDX  	#ERR
        call	PD			;	 BSR  	PD
        TBA				;	 TBA
        CLRB				;	 CLRB
        call	PRACC			;	 BSR  	PRACC
	LDX  	LNADRS			;        LDX  	LNADRS
        btfsc	FSR0H,7			;	 BMI  	C9
	bra	C9
        call	NWLINE			;	 BSR  	NWLINE
        call	LISTX			;	 BSR  	LISTX
        bra	C9			;	 BRA  	C9
;
PREXPR	call	EXPRPP			;PREXPR	 JSR  	EXPRPP
PRACC   PSHA				;PRACC	 PSHA
        PSHB				;	 PSHB
	STX  	_Z			;	 STX  	Z
        TSX				;	 TSX
        call	L84F			;	 BSR  	L84F
        PULB				;	 PULB
        PULA				;	 PULA
        return				;	 RTS
;
INFFF	call	INEEE			;INFFF   JSR  	INEEE
	movwf	Areg			;	 CMPA 	#$60
	btfsc	Areg,6			;	 BCS  	L948
	bcf	Areg,5			;	 SUBA 	#$20
	movlw	0x1B			;L948    CMPA 	#$25
	subwf	Areg,W			;	 BNE  	L94E
	skpnz				;	 LDAA 	#$40
	bra	ESC			;L94E    RTS
	movlw	0x08
	subwf	Areg,W
	skpz
	bra	OUTFFF
BS	movlw	0x0F
	bra	INFFF0
ESC	movlw	0x03
INFFF0	movwf	Areg
	return

OUTFFF	movf	Areg,W
	goto	OUTEEE

PSHSP	movf	FSR0H,W
	movwf	XHreg
	movf	FSR0L,W
	movwf	XLreg
	movf	SHreg,W
	movwf	FSR0H
	movf	SLreg,W
	movwf	FSR0L
	movlw	.15
	movwf	Temp
	banksel	STKPTR
_PSH	decf	STKPTR,F
	movf	TOSL,W
	movwi	INDF0--
	movf	TOSH,W
	movwi	INDF0--
	decfsz	Temp,F
	bra	_PSH
	decf	STKPTR,F
	bra	_PE

POPSP	movf	FSR0H,W
	movwf	XHreg
	movf	FSR0L,W
	movwf	XLreg
	movf	SHreg,W
	movwf	FSR0H
	movf	SLreg,W
	movwf	FSR0L
	movlw	.15
	movwf	Temp
	banksel	STKPTR
_POP	incf	STKPTR,F
	moviw	++INDF0
	movwf	TOSH
	moviw	++INDF0
	movwf	TOSL
	decfsz	Temp,F
	bra	_POP
	incf	STKPTR,F
_PE	movlb	.0
	movf	FSR0H,W
	movwf	SHreg
	movf	FSR0L,W
	movwf	SLreg
	movf	XHreg,W
	movwf	FSR0H
	movf	XLreg,W
	movwf	FSR0L
	return


RRESET	call	_CRLF			;New Line
	movlw	HIGH(MES001+0x8000)
	movwf	FSR0H
	movlw	LOW(MES001+0x8000)
	movwf	FSR0L
	call	MES

cmd_select
	call	_CRLF			;New Line
	call	INEEE			;input commands
	movlw	.7
	btfsc	TAreg,6
	subwf	TAreg,F			;0_F -> 0x30_0x3F, G_H -> 0x40_0x41
	movlw	0x1F
	andwf	TAreg,F			;0_F -> 0x10_0x1F, G_H -> 0x00_0x01

	btfss	TAreg,4
	goto	gh_cmd			;**

n_cmd	bcf	TAreg,4			;0_F -> 0x00_0x0F
	bsf	TAreg,5			;0_F -> 0x20_0x2F
	call	dump
	bra	RRESET

gh_cmd	btfsc	TAreg,0		;Basic Start	;**
	goto	Hstart		;Hot		;**
	goto	Cstart		;Cold		;**

; --------------------------------------------------------------------
;		Display Dump
; --------------------------------------------------------------------

dump	movlw	HIGH(MES002+0x8000)	;ADRS+00+01..+0E+0F
	movwf	FSR0H
	movlw	LOW(MES002+0x8000)
	movwf	FSR0L
	call	MES

LINE	movlw	.52			;------------------
	movwf	TBreg
LLOOP	call 	_M1
	decfsz	TBreg,F
	bra	LLOOP

	movf	TAreg,W			;Address
	movwf	FSR0H
	clrf	FSR0L

D2LOOP	call	_CRLF			;New Line
	movf	FSR0H,W			;XXXX
	call	PUTHEX2
	movf	FSR0L,W
	call	PUTHEX2
D3LOOP	call	_SP			;XXXX XX XX.. XX XX
	call	dbg99
	movf	INDF0,W
	call	PUTHEX2
	movlw	.1
	addwf	FSR0L,F
	skpdc
	bra	D3LOOP
	skpz
	bra	D2LOOP

; --------------------------------------------------------------------
;		New Line
; --------------------------------------------------------------------

_CRLF:
	MOVLW	0x0D
	CALL	OUTEEE
	MOVLW	0x0A

; --------------------------------------------------------------------
;		PUTC
; --------------------------------------------------------------------

OUTEEE
	banksel	TX1STA
	btfss 	TX1STA,TRMT
	bra 	$-1
	movwf	TX1REG
_ext	movlb	.0
	return

; --------------------------------------------------------------------
;		Display Message
; --------------------------------------------------------------------

MES	moviw	INDF0++
	skpnz
	bra	_CRLF			;New Line
	call	OUTEEE
	bra	MES

; --------------------------------------------------------------------
;		Display HEX 2 words
; --------------------------------------------------------------------

PUTHEX2:
	MOVWF	TBreg			;Breg=W
	SWAPF	TBreg,W			;Replace the lower 4bits and upper 4bits
	CALL	PUTHEX			;put HEX char
	MOVF	TBreg,W			;
PUTHEX:
	ANDLW	B'00001111'		;W=B'00001111'
	MOVWF	TAreg			;Areg="0000XXXX"
	MOVLW	0x0A			;W=0x0A
	SUBWF	TAreg,W			;W=Areg-W
	MOVLW	0x30			;
	BTFSC	STATUS,C		;W<0x0A
	ADDLW	0x07			;
	ADDWF	TAreg,W			;
	BRA	OUTEEE

; --------------------------------------------------------------------
;		GETC
; --------------------------------------------------------------------

INEEE
	banksel	PIR1
	btfss 	PIR1,RCIF		;test RX
	bra 	$-1			;not recive
	banksel	RC1REG
	movf 	RC1REG,W
	movwf	TAreg
	bra	_ext

; --------------------------------------------------------------------
;		Minus
; --------------------------------------------------------------------

_M:	CALL	OUTEEE
_M1:	MOVLW	'-'
	BRA	OUTEEE

; --------------------------------------------------------------------
;		Space
; --------------------------------------------------------------------

_SP2:	call	PUTHEX2
_SP:	MOVLW	0x20
	BRA	OUTEEE

; --------------------------------------------------------------------
;		for Debug
; --------------------------------------------------------------------

dbg	swapf	STATUS,W		;save STATUS
	movwf	TSTATUS
	movf	FSR0H,W			;save X
	movwf	THreg
	movf	FSR0L,W
	movwf	TLreg
	call	_CRLF

	movlw	"P"		;P-XXXX X-XXXX A-XX B-XX C-XX S-XXXX H-XX XXXX XXXX
	call	_M
	banksel	STKPTR
	movf	TOSL,W
	movwf	Temp
	movf	TOSH,W
	movlb	.0
	call	PUTHEX2
	movf	Temp,W
	call	_SP2

	movlw	"X"
	call	_M
	movf	THreg,W
	call	PUTHEX2
	movf	TLreg,W
	call	_SP2

	movlw	"A"
	call	_M
	movf	Areg,W
	call	_SP2

	movlw	"B"
	call	_M
	movf	Breg,W
	call	_SP2

	movlw	"C"
	call	_M
	swapf	TSTATUS,W
	call	_SP2

	movlw	"S"
	call	_M
	movf	FSR1H,W
	call	PUTHEX2
	movf	FSR1L,W
	call	_SP2

	movlw	"H"
	call	_M
	banksel	STKPTR
	decf	STKPTR,W
	movwf	Temp
	movlb	.0
	call	_SP2

	banksel	STKPTR
	decf	STKPTR,F
	decf	STKPTR,F
	movf	TOSL,W
	movwf	FSR0L
	movf	TOSH,W
	movwf	FSR0H
	incf	STKPTR,F
	movf	TOSL,W
	movwf	Temp
	movf	TOSH,W
	incf	STKPTR,F
	movlb	.0
	call	PUTHEX2
	movf	Temp,W
	call	_SP2

	movf	FSR0H,W
	call	PUTHEX2
	movf	FSR0L,W
	call	_SP2
	call	_CRLF		;New Line

	call	INEEE		;key input
	sublw	'D'
	skpz
	bra	nodmp

	call	_CRLF		;dump
	call	_CRLF
	clrf	TAreg
	call	dump
nodmp	movf	THreg,W		;load X
	movwf	FSR0H
	movf	TLreg,W
	movwf	FSR0L
dbg99	swapf	TSTATUS,W	;load STATUS
	movwf	STATUS
	return

; --------------------------------------------------------------------

	org	0x0800
;
TABLE2  DW  	'L','I','S',0xD4
	DW	HIGH(_LIST),LOW(_LIST)
;       DW	'L','O','A',0xC4
;	DW	HIGH(LOAD),LOW(LOAD)
        DW	'R','U',0xCE
	DW	HIGH(RUN),LOW(RUN)
        DW	'E',0xD8
	DW	HIGH(RRESET),LOW(RRESET)
        DW	'A','U','T',0xCF
	DW	HIGH(AUTO),LOW(AUTO)
        DW	'N','E',0xD7
	DW	HIGH(NEW),LOW(NEW)
;
TABLE	DW	'L','E',0xD4
	DW	HIGH(LET),LOW(LET)
	DW	'I',0xC6
	DW	HIGH(_IF),LOW(_IF)
        DW	'G','O','T',0xCF
	DW	HIGH(_GOTO),LOW(_GOTO)
        DW	'G','O','S','U',0xC2
	DW	HIGH(GOSUB),LOW(GOSUB)
	DW	'R','E',0xD4
	DW	HIGH(PLX),LOW(PLX)
        DW	'N','E','X',0xD4
	DW	HIGH(NEXT),LOW(NEXT)
	DW	'F','O',0xD2
	DW	HIGH(FOR),LOW(FOR)
        DW	'T','H','E',0xCE
	DW	HIGH(THEN),LOW(THEN)
	DW	'R','E',0xCD
	DW	HIGH(NXTL2),LOW(NXTL2)
        DW	'P','R','I','N',0xD4
	DW	HIGH(PRINT),LOW(PRINT)
        DW	'I','N','P','U',0xD4
	DW	HIGH(INPUT),LOW(INPUT)
	DW	'P',0xD2
	DW	HIGH(PRINT),LOW(PRINT)
	DW	'I',0xCE
	DW	HIGH(INPUT),LOW(INPUT)
        DW	'S','T','O',0xD0
	DW	HIGH(STOP),LOW(STOP)
	DW	'E','N',0xC4
	DW	HIGH(CONTRL),LOW(CONTRL)
        DW  	0xFF
	DW	HIGH(LET),LOW(LET)
;
TABLE3  DW	'R','N','D',0xA8
	DW	HIGH(RANDOM),LOW(RANDOM)
  	DW	'A','B','S',0xA8
	DW	HIGH(ABS),LOW(ABS)
  	DW	'M','O','D',0xA8
	DW	HIGH(MOD),LOW(MOD)
;  	DW	'U','S','R',0xA8
;	DW	HIGH(USER),LOW(USER)
        DW  	0xFF
	DW	HIGH(NOTFNC),LOW(NOTFNC)
;
TABLE4	DW	'T',0xCF
;
TOMSG   DW	0x12,0x34
        DW	'S','T','E',0xD0
;
STPMSG  DW	0xAB,0xCD
;
TABLE5  DW	'C','H','R',0xA8
	DW	HIGH(CHR),LOW(CHR)
  	DW	'T','A','B',0xA8
	DW	HIGH(_TAB),LOW(_TAB)
        DW  	0xFF
	DW	HIGH(PREXPR),LOW(PREXPR)
;
ERR	DW	'E','R','R','O','R',' '
	DW  	0x00
;
RDYMSG	DW	'R','E','A','D','Y'
;
CRLF	DW	0x0D,0x0A
	DW  	0x00

MES001	DW	'0','-','3',':','R','a','m',',',' '
	DW	'G',':','C','o','l','d',',',' '
	DW	'H',':','H','o','t',' ','>'
	DW  	0x00

MES002	DW	'A','D','R','S','+','0','0','+','0','1','+','0','2','+','0','3'
	DW	'+','0','4','+','0','5','+','0','6','+','0','7','+','0','8','+'
	DW	'0','9','+','0','A','+','0','B','+','0','C','+','0','D','+','0'
	DW	'E','+','0','F'
	DW  	0x00

; --------------------------------------------------------------------

	org	0x0900

	DW 0x00,0x32,0x4B,0x3D,0x30,0x3A,0x42,0x3D,0x30,0x3A,0x44,0x3D,0x33,0x30,0x3A,0x4F
	DW 0x3D,0x30,0x3A,0x49,0x3D,0x30,0x3A,0x59,0x3D,0x32,0x30,0x30,0x30,0x3A,0x50,0x52
	DW 0x22,0x53,0x54,0x41,0x52,0x44,0x41,0x54,0x45,0x20,0x33,0x32,0x30,0x30,0x20,0x59
	DW 0x4F,0x55,0x52,0x20,0x4D,0x49,0x53,0x53,0x49,0x4F,0x4E,0x20,0x49,0x53,0x20,0x22
	DW 0x3B,0x00,0x00,0x64,0x4A,0x3D,0x28,0x52,0x4E,0x44,0x28,0x44,0x29,0x3C,0x32,0x29
	DW 0x3A,0x42,0x3D,0x42,0x2B,0x4A,0x3A,0x4D,0x3D,0x52,0x4E,0x44,0x28,0x59,0x29,0x00
	DW 0x00,0x69,0x4D,0x3D,0x28,0x4D,0x3C,0x32,0x30,0x39,0x29,0x2B,0x28,0x4D,0x3C,0x39
	DW 0x39,0x29,0x2B,0x28,0x4D,0x3C,0x34,0x39,0x29,0x2B,0x28,0x4D,0x3C,0x32,0x33,0x29
	DW 0x2B,0x28,0x4D,0x3C,0x39,0x29,0x2B,0x28,0x4D,0x3C,0x32,0x29,0x00,0x00,0x6E,0x4B
	DW 0x3D,0x4B,0x2B,0x4D,0x3A,0x40,0x28,0x49,0x29,0x3D,0x2D,0x31,0x30,0x30,0x2A,0x4D
	DW 0x2D,0x31,0x30,0x2A,0x4A,0x2D,0x52,0x4E,0x44,0x28,0x37,0x29,0x2D,0x31,0x3A,0x49
	DW 0x3D,0x49,0x2B,0x31,0x3A,0x49,0x46,0x49,0x3C,0x3D,0x36,0x33,0x20,0x47,0x4F,0x54
	DW 0x4F,0x31,0x30,0x30,0x00,0x01,0x2C,0x50,0x52,0x22,0x20,0x54,0x4F,0x20,0x44,0x45
	DW 0x53,0x54,0x52,0x4F,0x59,0x20,0x22,0x3B,0x4B,0x3B,0x22,0x20,0x4B,0x4C,0x49,0x4E
	DW 0x47,0x4F,0x4E,0x53,0x20,0x49,0x4E,0x20,0x33,0x30,0x20,0x53,0x54,0x41,0x52,0x44
	DW 0x41,0x54,0x45,0x53,0x2E,0x22,0x00,0x01,0x5E,0x50,0x52,0x22,0x54,0x48,0x45,0x52
	DW 0x45,0x20,0x41,0x52,0x45,0x20,0x22,0x3B,0x42,0x3B,0x22,0x20,0x53,0x54,0x41,0x52
	DW 0x42,0x41,0x53,0x45,0x53,0x2E,0x22,0x00,0x01,0x90,0x55,0x3D,0x52,0x4E,0x44,0x28
	DW 0x38,0x29,0x2B,0x31,0x3A,0x56,0x3D,0x52,0x4E,0x44,0x28,0x38,0x29,0x2B,0x31,0x3A
	DW 0x58,0x3D,0x52,0x4E,0x44,0x28,0x38,0x29,0x2B,0x31,0x3A,0x59,0x3D,0x52,0x4E,0x44
	DW 0x28,0x38,0x29,0x2B,0x31,0x00,0x01,0xC2,0x49,0x3D,0x37,0x31,0x00,0x01,0xC4,0x40
	DW 0x28,0x49,0x29,0x3D,0x30,0x3A,0x49,0x3D,0x49,0x2B,0x31,0x3A,0x49,0x46,0x49,0x3C
	DW 0x3D,0x31,0x35,0x32,0x20,0x47,0x4F,0x54,0x4F,0x34,0x35,0x32,0x00,0x01,0xCA,0x40
	DW 0x28,0x38,0x2A,0x58,0x2B,0x59,0x2B,0x36,0x32,0x29,0x3D,0x34,0x3A,0x49,0x3D,0x38
	DW 0x2A,0x55,0x2B,0x56,0x2D,0x39,0x3A,0x40,0x28,0x49,0x29,0x3D,0x41,0x42,0x53,0x28
	DW 0x40,0x28,0x49,0x29,0x29,0x3A,0x4D,0x3D,0x40,0x49,0x3A,0x4E,0x3D,0x4D,0x2F,0x31
	DW 0x30,0x30,0x00,0x01,0xF6,0x49,0x46,0x4E,0x3D,0x30,0x20,0x47,0x4F,0x54,0x4F,0x35
	DW 0x35,0x32,0x00,0x01,0xF8,0x49,0x3D,0x31,0x3A,0x4A,0x3D,0x31,0x00,0x01,0xFA,0x47
	DW 0x4F,0x53,0x55,0x42,0x20,0x31,0x36,0x35,0x30,0x00,0x01,0xFC,0x40,0x28,0x4A,0x2B
	DW 0x31,0x33,0x34,0x29,0x3D,0x33,0x30,0x30,0x3A,0x40,0x28,0x4A,0x2B,0x31,0x34,0x30
	DW 0x29,0x3D,0x53,0x3A,0x40,0x28,0x4A,0x2B,0x31,0x34,0x36,0x29,0x3D,0x54,0x3A,0x4A
	DW 0x3D,0x4A,0x2B,0x31,0x3A,0x49,0x46,0x4A,0x3C,0x3D,0x4E,0x20,0x47,0x4F,0x54,0x4F
	DW 0x35,0x30,0x36,0x00,0x02,0x28,0x4D,0x3D,0x4D,0x4F,0x44,0x28,0x4D,0x2C,0x31,0x30
	DW 0x30,0x29,0x3A,0x49,0x46,0x4D,0x2F,0x31,0x30,0x3E,0x30,0x20,0x49,0x3D,0x32,0x3A
	DW 0x4D,0x3D,0x4D,0x4F,0x44,0x28,0x4D,0x2C,0x31,0x30,0x29,0x3A,0x47,0x4F,0x53,0x55
	DW 0x42,0x20,0x31,0x36,0x35,0x30,0x00,0x02,0x58,0x4A,0x3D,0x31,0x3A,0x49,0x3D,0x33
	DW 0x3A,0x47,0x4F,0x53,0x55,0x42,0x20,0x31,0x37,0x35,0x30,0x00,0x02,0x60,0x47,0x4F
	DW 0x53,0x55,0x42,0x20,0x31,0x36,0x35,0x30,0x00,0x02,0x62,0x4A,0x3D,0x4A,0x2B,0x31
	DW 0x3A,0x49,0x46,0x4A,0x3C,0x3D,0x4D,0x20,0x47,0x4F,0x54,0x4F,0x36,0x30,0x38,0x00
	DW 0x02,0x8A,0x49,0x46,0x4F,0x3D,0x30,0x20,0x47,0x4F,0x53,0x55,0x42,0x20,0x31,0x34
	DW 0x35,0x30,0x00,0x02,0x8C,0x49,0x46,0x4E,0x3E,0x30,0x20,0x47,0x4F,0x53,0x55,0x42
	DW 0x20,0x33,0x33,0x30,0x30,0x00,0x02,0x8E,0x49,0x46,0x4B,0x3D,0x30,0x20,0x47,0x4F
	DW 0x54,0x4F,0x36,0x35,0x30,0x30,0x00,0x03,0xB6,0x49,0x46,0x44,0x3C,0x30,0x20,0x47
	DW 0x4F,0x54,0x4F,0x36,0x36,0x30,0x30,0x00,0x03,0xE8,0x49,0x46,0x45,0x3C,0x30,0x20
	DW 0x47,0x4F,0x54,0x4F,0x36,0x37,0x30,0x30,0x00,0x04,0xB0,0x53,0x3D,0x32,0x32,0x30
	DW 0x30,0x3A,0x47,0x3D,0x31,0x38,0x30,0x30,0x3A,0x4C,0x3D,0x32,0x30,0x30,0x30,0x3A
	DW 0x50,0x3D,0x32,0x36,0x30,0x30,0x3A,0x52,0x3D,0x34,0x32,0x30,0x30,0x3A,0x57,0x3D
	DW 0x34,0x36,0x35,0x30,0x3A,0x54,0x3D,0x35,0x35,0x35,0x30,0x00,0x04,0xB2,0x49,0x4E
	DW 0x20,0x22,0x43,0x4F,0x4D,0x4D,0x41,0x4E,0x44,0x20,0x22,0x2C,0x41,0x00,0x04,0xB4
	DW 0x49,0x46,0x28,0x41,0x3D,0x53,0x29,0x2B,0x28,0x41,0x3D,0x47,0x29,0x2B,0x28,0x41
	DW 0x3D,0x4C,0x29,0x2B,0x28,0x41,0x3D,0x50,0x29,0x2B,0x28,0x41,0x3D,0x52,0x29,0x2B
	DW 0x28,0x41,0x3D,0x57,0x29,0x2B,0x28,0x41,0x3D,0x54,0x29,0x3D,0x30,0x20,0x47,0x4F
	DW 0x54,0x4F,0x31,0x32,0x30,0x32,0x00,0x04,0xB6,0x47,0x4F,0x54,0x4F,0x41,0x00,0x05
	DW 0xAA,0x49,0x3D,0x58,0x2D,0x31,0x00,0x05,0xAC,0x4A,0x3D,0x59,0x2D,0x31,0x00,0x05
	DW 0xAE,0x49,0x46,0x28,0x58,0x3E,0x30,0x29,0x2B,0x28,0x58,0x3C,0x39,0x29,0x2B,0x28
	DW 0x59,0x3E,0x30,0x29,0x2B,0x28,0x59,0x3C,0x39,0x29,0x2B,0x28,0x40,0x28,0x38,0x2A
	DW 0x49,0x2B,0x4A,0x2B,0x36,0x32,0x29,0x3D,0x32,0x29,0x3D,0x35,0x20,0x47,0x4F,0x54
	DW 0x4F,0x31,0x35,0x35,0x30,0x00,0x05,0xB0,0x4A,0x3D,0x4A,0x2B,0x31,0x3A,0x49,0x46
	DW 0x4A,0x3C,0x3D,0x59,0x2B,0x31,0x20,0x47,0x4F,0x54,0x4F,0x31,0x34,0x35,0x34,0x00
	DW 0x05,0xB2,0x49,0x3D,0x49,0x2B,0x31,0x3A,0x49,0x46,0x49,0x3C,0x3D,0x58,0x2B,0x31
	DW 0x20,0x47,0x4F,0x54,0x4F,0x31,0x34,0x35,0x32,0x00,0x05,0xEE,0x52,0x45,0x54,0x00
	DW 0x06,0x0E,0x4F,0x3D,0x31,0x3A,0x50,0x52,0x22,0x53,0x55,0x4C,0x55,0x20,0x43,0x41
	DW 0x50,0x54,0x41,0x49,0x4E,0x2C,0x20,0x57,0x45,0x20,0x41,0x52,0x45,0x20,0x44,0x4F
	DW 0x43,0x4B,0x45,0x44,0x20,0x41,0x54,0x20,0x53,0x54,0x41,0x52,0x42,0x41,0x53,0x45
	DW 0x2C,0x22,0x00,0x06,0x40,0x45,0x3D,0x34,0x30,0x30,0x30,0x3A,0x46,0x3D,0x31,0x30
	DW 0x3A,0x49,0x3D,0x36,0x34,0x00,0x06,0x42,0x40,0x49,0x3D,0x30,0x3A,0x49,0x3D,0x49
	DW 0x2B,0x31,0x3A,0x49,0x46,0x49,0x3C,0x3D,0x37,0x30,0x20,0x47,0x4F,0x54,0x4F,0x31
	DW 0x36,0x30,0x32,0x00,0x06,0x4E,0x52,0x45,0x54,0x00,0x06,0x72,0x53,0x3D,0x52,0x4E
	DW 0x44,0x28,0x38,0x29,0x2B,0x31,0x3A,0x54,0x3D,0x52,0x4E,0x44,0x28,0x38,0x29,0x2B
	DW 0x31,0x3A,0x41,0x3D,0x38,0x2A,0x53,0x2B,0x54,0x2B,0x36,0x32,0x3A,0x49,0x46,0x40
	DW 0x28,0x41,0x29,0x3E,0x30,0x20,0x47,0x4F,0x54,0x4F,0x31,0x36,0x35,0x30,0x00,0x06
	DW 0x74,0x40,0x41,0x3D,0x49,0x3A,0x52,0x45,0x54,0x00,0x06,0xD6,0x50,0x52,0x22,0x45
	DW 0x4E,0x54,0x45,0x52,0x50,0x52,0x49,0x53,0x45,0x20,0x49,0x4E,0x20,0x51,0x28,0x22
	DW 0x3B,0x55,0x3B,0x22,0x2C,0x22,0x3B,0x56,0x3B,0x22,0x29,0x20,0x53,0x28,0x22,0x3B
	DW 0x58,0x3B,0x22,0x2C,0x22,0x3B,0x59,0x3B,0x22,0x29,0x22,0x00,0x06,0xD8,0x52,0x45
	DW 0x54,0x00,0x06,0xFE,0x49,0x46,0x5A,0x2F,0x31,0x30,0x30,0x3C,0x3E,0x30,0x20,0x47
	DW 0x4F,0x54,0x4F,0x31,0x37,0x39,0x35,0x00,0x07,0x00,0x49,0x46,0x5A,0x2F,0x31,0x30
	DW 0x3D,0x30,0x20,0x50,0x52,0x22,0x20,0x22,0x3B,0x00,0x07,0x02,0x50,0x52,0x22,0x20
	DW 0x22,0x3B,0x00,0x07,0x03,0x50,0x52,0x22,0x20,0x22,0x3B,0x5A,0x3B,0x00,0x07,0x06
	DW 0x52,0x45,0x54,0x00,0x07,0x08,0x47,0x4F,0x53,0x55,0x42,0x20,0x31,0x37,0x35,0x30
	DW 0x00,0x07,0x0A,0x4A,0x3D,0x32,0x3A,0x47,0x4F,0x53,0x55,0x42,0x20,0x33,0x37,0x35
	DW 0x30,0x00,0x07,0x0E,0x49,0x46,0x49,0x3C,0x3E,0x30,0x20,0x47,0x4F,0x54,0x4F,0x31
	DW 0x32,0x30,0x30,0x00,0x07,0x3A,0x50,0x52,0x22,0x20,0x4F,0x46,0x20,0x47,0x41,0x4C
	DW 0x41,0x58,0x59,0x20,0x4D,0x41,0x50,0x22,0x00,0x07,0x3C,0x49,0x3D,0x30,0x00,0x07
	DW 0x42,0x4A,0x3D,0x30,0x3A,0x50,0x52,0x49,0x2B,0x31,0x3B,0x00,0x07,0x44,0x41,0x3D
	DW 0x40,0x28,0x38,0x2A,0x49,0x2B,0x4A,0x29,0x3A,0x5A,0x3D,0x41,0x2A,0x28,0x41,0x3E
	DW 0x30,0x29,0x3A,0x47,0x4F,0x53,0x55,0x42,0x20,0x31,0x37,0x39,0x30,0x00,0x07,0x70
	DW 0x4A,0x3D,0x4A,0x2B,0x31,0x3A,0x49,0x46,0x4A,0x3C,0x3D,0x37,0x20,0x47,0x4F,0x54
	DW 0x4F,0x31,0x38,0x36,0x30,0x00,0x07,0x74,0x50,0x52,0x00,0x07,0x76,0x49,0x3D,0x49
	DW 0x2B,0x31,0x3A,0x49,0x46,0x49,0x3C,0x3D,0x37,0x20,0x47,0x4F,0x54,0x4F,0x31,0x38
	DW 0x35,0x38,0x00,0x07,0x9E,0x49,0x3D,0x31,0x3A,0x50,0x52,0x22,0x20,0x20,0x20,0x20
	DW 0x22,0x3B,0x00,0x07,0xA0,0x50,0x52,0x49,0x3B,0x22,0x20,0x20,0x20,0x22,0x3B,0x00
	DW 0x07,0xA2,0x49,0x3D,0x49,0x2B,0x31,0x3A,0x49,0x46,0x49,0x3C,0x3D,0x38,0x20,0x47
	DW 0x4F,0x54,0x4F,0x31,0x39,0x35,0x32,0x00,0x07,0xA6,0x50,0x52,0x00,0x07,0xA8,0x47
	DW 0x4F,0x54,0x4F,0x31,0x32,0x30,0x30,0x00,0x07,0xD0,0x47,0x4F,0x53,0x55,0x42,0x20
	DW 0x31,0x37,0x35,0x30,0x00,0x07,0xD2,0x4A,0x3D,0x33,0x3A,0x47,0x4F,0x53,0x55,0x42
	DW 0x20,0x33,0x37,0x35,0x30,0x00,0x07,0xD6,0x49,0x46,0x49,0x3C,0x3E,0x30,0x20,0x47
	DW 0x4F,0x54,0x4F,0x31,0x32,0x30,0x30,0x00,0x08,0x02,0x50,0x52,0x00,0x08,0x04,0x49
	DW 0x3D,0x55,0x2D,0x31,0x00,0x08,0x06,0x4A,0x3D,0x56,0x2D,0x31,0x00,0x08,0x08,0x4D
	DW 0x3D,0x38,0x2A,0x49,0x2B,0x4A,0x2D,0x39,0x3A,0x49,0x46,0x28,0x49,0x3C,0x31,0x29
	DW 0x2B,0x28,0x49,0x3E,0x38,0x29,0x2B,0x28,0x4A,0x3C,0x31,0x29,0x2B,0x28,0x4A,0x3E
	DW 0x38,0x29,0x3E,0x30,0x20,0x5A,0x3D,0x30,0x3A,0x47,0x4F,0x54,0x4F,0x32,0x31,0x35
	DW 0x30,0x00,0x08,0x36,0x5A,0x3D,0x41,0x42,0x53,0x28,0x40,0x4D,0x29,0x3A,0x40,0x4D
	DW 0x3D,0x5A,0x00,0x08,0x66,0x47,0x4F,0x53,0x55,0x42,0x20,0x31,0x37,0x39,0x30,0x00
	DW 0x08,0x68,0x4A,0x3D,0x4A,0x2B,0x31,0x3A,0x49,0x46,0x4A,0x3C,0x3D,0x56,0x2B,0x31
	DW 0x20,0x47,0x4F,0x54,0x4F,0x32,0x30,0x35,0x36,0x00,0x08,0x6C,0x50,0x52,0x00,0x08
	DW 0x70,0x49,0x3D,0x49,0x2B,0x31,0x3A,0x49,0x46,0x49,0x3C,0x3D,0x55,0x2B,0x31,0x20
	DW 0x47,0x4F,0x54,0x4F,0x32,0x30,0x35,0x34,0x00,0x08,0x72,0x47,0x4F,0x54,0x4F,0x31
	DW 0x32,0x30,0x30,0x00,0x08,0x98,0x47,0x4F,0x53,0x55,0x42,0x20,0x31,0x37,0x35,0x30
	DW 0x00,0x08,0x9A,0x4A,0x3D,0x31,0x3A,0x47,0x4F,0x53,0x55,0x42,0x20,0x33,0x37,0x35
	DW 0x30,0x00,0x08,0x9E,0x49,0x46,0x49,0x3E,0x30,0x20,0x47,0x4F,0x54,0x4F,0x31,0x32
	DW 0x30,0x30,0x00,0x08,0xFC,0x49,0x3D,0x31,0x3A,0x50,0x52,0x00,0x09,0x00,0x4A,0x3D
	DW 0x31,0x3A,0x50,0x52,0x49,0x3B,0x00,0x09,0x04,0x4D,0x3D,0x40,0x28,0x38,0x2A,0x49
	DW 0x2B,0x4A,0x2B,0x36,0x32,0x29,0x00,0x09,0x08,0x49,0x46,0x4D,0x3D,0x30,0x20,0x50
	DW 0x52,0x22,0x20,0x2E,0x22,0x3B,0x00,0x09,0x0A,0x49,0x46,0x4D,0x3D,0x31,0x20,0x50
	DW 0x52,0x22,0x20,0x4B,0x22,0x3B,0x00,0x09,0x0C,0x49,0x46,0x4D,0x3D,0x32,0x20,0x50
	DW 0x52,0x22,0x20,0x42,0x22,0x3B,0x00,0x09,0x0E,0x49,0x46,0x4D,0x3D,0x33,0x20,0x50
	DW 0x52,0x22,0x20,0x2A,0x22,0x3B,0x00,0x09,0x10,0x49,0x46,0x4D,0x3D,0x34,0x20,0x50
	DW 0x52,0x22,0x20,0x45,0x22,0x3B,0x00,0x09,0xF6,0x4A,0x3D,0x4A,0x2B,0x31,0x3A,0x49
	DW 0x46,0x4A,0x3C,0x3D,0x38,0x20,0x47,0x4F,0x54,0x4F,0x32,0x33,0x30,0x38,0x00,0x09
	DW 0xFA,0x50,0x52,0x00,0x09,0xFC,0x49,0x3D,0x49,0x2B,0x31,0x3A,0x49,0x46,0x49,0x3C
	DW 0x3D,0x38,0x20,0x47,0x4F,0x54,0x4F,0x32,0x33,0x30,0x34,0x00,0x0A,0x00,0x49,0x3D
	DW 0x31,0x3A,0x50,0x52,0x22,0x20,0x22,0x3B,0x00,0x0A,0x04,0x50,0x52,0x22,0x20,0x22
	DW 0x3B,0x49,0x3B,0x00,0x0A,0x06,0x49,0x3D,0x49,0x2B,0x31,0x3A,0x49,0x46,0x49,0x3C
	DW 0x3D,0x38,0x20,0x47,0x4F,0x54,0x4F,0x32,0x35,0x36,0x34,0x00,0x0A,0x0A,0x50,0x52
	DW 0x00,0x0A,0x0C,0x47,0x4F,0x54,0x4F,0x31,0x32,0x30,0x30,0x00,0x0A,0x28,0x4A,0x3D
	DW 0x35,0x3A,0x47,0x4F,0x53,0x55,0x42,0x20,0x33,0x37,0x35,0x30,0x00,0x0A,0x2C,0x49
	DW 0x46,0x49,0x3C,0x3E,0x30,0x20,0x47,0x4F,0x54,0x4F,0x31,0x32,0x30,0x30,0x00,0x0A
	DW 0x5A,0x50,0x52,0x22,0x20,0x45,0x4E,0x45,0x52,0x47,0x49,0x5A,0x45,0x44,0x20,0x22
	DW 0x3B,0x45,0x3B,0x00,0x0A,0x5C,0x49,0x4E,0x22,0x20,0x57,0x48,0x41,0x54,0x20,0x55
	DW 0x4E,0x49,0x54,0x53,0x20,0x54,0x4F,0x20,0x46,0x49,0x52,0x45,0x20,0x22,0x2C,0x41
	DW 0x00,0x0A,0x5E,0x49,0x46,0x28,0x41,0x3E,0x30,0x29,0x2A,0x28,0x41,0x3C,0x45,0x29
	DW 0x3D,0x30,0x20,0x47,0x4F,0x54,0x4F,0x31,0x32,0x30,0x30,0x00,0x0A,0x8E,0x45,0x3D
	DW 0x45,0x2D,0x41,0x3A,0x49,0x46,0x4E,0x3E,0x30,0x20,0x47,0x4F,0x54,0x4F,0x32,0x38
	DW 0x30,0x30,0x00,0x0A,0xC2,0x50,0x52,0x22,0x50,0x48,0x41,0x53,0x45,0x52,0x20,0x46
	DW 0x49,0x52,0x45,0x44,0x20,0x41,0x54,0x20,0x45,0x4D,0x50,0x54,0x59,0x20,0x53,0x50
	DW 0x41,0x43,0x45,0x2E,0x22,0x00,0x0A,0xC4,0x47,0x4F,0x54,0x4F,0x36,0x35,0x30,0x00
	DW 0x0A,0xF0,0x41,0x3D,0x41,0x2F,0x4E,0x3A,0x4D,0x3D,0x31,0x33,0x35,0x00,0x0A,0xF4
	DW 0x49,0x46,0x40,0x4D,0x3D,0x30,0x20,0x47,0x4F,0x54,0x4F,0x32,0x39,0x30,0x30,0x00
	DW 0x0B,0x22,0x47,0x4F,0x53,0x55,0x42,0x20,0x32,0x39,0x35,0x30,0x00,0x0B,0x24,0x50
	DW 0x52,0x53,0x3B,0x22,0x20,0x55,0x4E,0x49,0x54,0x53,0x20,0x48,0x49,0x54,0x20,0x22
	DW 0x00,0x0B,0x26,0x47,0x4F,0x53,0x55,0x42,0x20,0x33,0x30,0x35,0x30,0x00,0x0B,0x54
	DW 0x4D,0x3D,0x4D,0x2B,0x31,0x3A,0x49,0x46,0x4D,0x3C,0x3D,0x31,0x34,0x30,0x20,0x47
	DW 0x4F,0x54,0x4F,0x32,0x38,0x30,0x34,0x00,0x0B,0x58,0x47,0x4F,0x54,0x4F,0x36,0x35
	DW 0x30,0x00,0x0B,0x86,0x49,0x46,0x41,0x3C,0x3D,0x31,0x30,0x39,0x30,0x20,0x47,0x4F
	DW 0x54,0x4F,0x33,0x30,0x30,0x30,0x00,0x0B,0x88,0x50,0x52,0x22,0x4F,0x56,0x45,0x52
	DW 0x20,0x4C,0x4F,0x41,0x44,0x45,0x44,0x22,0x00,0x0B,0x8A,0x4A,0x3D,0x34,0x3A,0x40
	DW 0x36,0x37,0x3D,0x31,0x3A,0x41,0x3D,0x39,0x3A,0x47,0x4F,0x53,0x55,0x42,0x20,0x33
	DW 0x37,0x35,0x30,0x00,0x0B,0xB8,0x49,0x3D,0x40,0x28,0x4D,0x2B,0x36,0x29,0x2D,0x58
	DW 0x3A,0x4A,0x3D,0x40,0x28,0x4D,0x2B,0x31,0x32,0x29,0x2D,0x59,0x3A,0x53,0x3D,0x41
	DW 0x2A,0x33,0x30,0x2F,0x28,0x33,0x30,0x2B,0x49,0x2A,0x49,0x2B,0x4A,0x2A,0x4A,0x29
	DW 0x2B,0x31,0x3A,0x52,0x45,0x54,0x00,0x0B,0xEA,0x50,0x52,0x22,0x4B,0x4C,0x49,0x4E
	DW 0x47,0x4F,0x4E,0x20,0x41,0x54,0x20,0x53,0x28,0x20,0x22,0x3B,0x40,0x28,0x4D,0x2B
	DW 0x36,0x29,0x3B,0x22,0x20,0x22,0x3B,0x40,0x28,0x4D,0x2B,0x31,0x32,0x29,0x3B,0x22
	DW 0x20,0x29,0x22,0x3B,0x00,0x0B,0xEC,0x40,0x4D,0x3D,0x40,0x4D,0x2D,0x53,0x3A,0x49
	DW 0x46,0x40,0x4D,0x3C,0x3D,0x30,0x20,0x47,0x4F,0x54,0x4F,0x33,0x31,0x35,0x30,0x00
	DW 0x0C,0x20,0x50,0x52,0x22,0x2A,0x2A,0x44,0x41,0x4D,0x41,0x47,0x45,0x44,0x2A,0x2A
	DW 0x22,0x00,0x0C,0x22,0x52,0x45,0x54,0x00,0x0C,0x4E,0x40,0x4D,0x3D,0x30,0x3A,0x5A
	DW 0x3D,0x38,0x2A,0x55,0x2B,0x56,0x2D,0x39,0x3A,0x40,0x5A,0x3D,0x40,0x5A,0x2D,0x31
	DW 0x30,0x30,0x3A,0x4B,0x3D,0x4B,0x2D,0x31,0x3A,0x4E,0x3D,0x4E,0x2D,0x31,0x3A,0x40
	DW 0x28,0x38,0x2A,0x40,0x28,0x4D,0x2B,0x36,0x29,0x2B,0x40,0x28,0x4D,0x2B,0x31,0x32
	DW 0x29,0x2B,0x36,0x32,0x29,0x3D,0x30,0x00,0x0C,0x8A,0x50,0x52,0x22,0x2A,0x2A,0x44
	DW 0x45,0x53,0x54,0x52,0x4F,0x59,0x45,0x44,0x2A,0x2A,0x22,0x00,0x0C,0x8C,0x52,0x45
	DW 0x54,0x00,0x0C,0xE4,0x50,0x52,0x22,0x4B,0x4C,0x49,0x4E,0x47,0x4F,0x4E,0x20,0x41
	DW 0x54,0x54,0x41,0x43,0x4B,0x22,0x00,0x0C,0xE6,0x49,0x46,0x4F,0x3D,0x30,0x20,0x47
	DW 0x4F,0x54,0x4F,0x33,0x33,0x35,0x30,0x00,0x0C,0xE8,0x50,0x52,0x22,0x53,0x54,0x41
	DW 0x52,0x42,0x41,0x53,0x45,0x20,0x50,0x52,0x4F,0x54,0x45,0x43,0x54,0x53,0x20,0x45
	DW 0x4E,0x54,0x45,0x52,0x50,0x52,0x49,0x53,0x45,0x22,0x00,0x0C,0xEA,0x52,0x45,0x54
	DW 0x00,0x0D,0x16,0x54,0x3D,0x30,0x3A,0x4D,0x3D,0x31,0x33,0x35,0x00,0x0D,0x1A,0x49
	DW 0x46,0x40,0x4D,0x3D,0x30,0x20,0x47,0x4F,0x54,0x4F,0x33,0x35,0x30,0x30,0x00,0x0D
	DW 0x48,0x41,0x3D,0x28,0x40,0x4D,0x2B,0x52,0x4E,0x44,0x28,0x40,0x4D,0x29,0x29,0x2F
	DW 0x32,0x3A,0x47,0x4F,0x53,0x55,0x42,0x20,0x32,0x39,0x35,0x30,0x00,0x0D,0x4A,0x54
	DW 0x3D,0x54,0x2B,0x53,0x3A,0x50,0x52,0x53,0x3B,0x22,0x20,0x55,0x4E,0x49,0x54,0x53
	DW 0x20,0x48,0x49,0x54,0x20,0x46,0x52,0x4F,0x4D,0x20,0x4B,0x4C,0x49,0x4E,0x47,0x4F
	DW 0x4E,0x20,0x41,0x54,0x20,0x53,0x28,0x22,0x3B,0x40,0x28,0x4D,0x2B,0x36,0x29,0x3B
	DW 0x22,0x2C,0x22,0x3B,0x40,0x28,0x4D,0x2B,0x31,0x32,0x29,0x3B,0x22,0x29,0x22,0x00
	DW 0x0D,0xAC,0x4D,0x3D,0x4D,0x2B,0x31,0x3A,0x49,0x46,0x4D,0x3C,0x3D,0x31,0x34,0x30
	DW 0x20,0x47,0x4F,0x54,0x4F,0x33,0x33,0x35,0x34,0x00,0x0D,0xB0,0x45,0x3D,0x45,0x2D
	DW 0x54,0x3A,0x49,0x46,0x45,0x3C,0x30,0x20,0x50,0x52,0x22,0x20,0x20,0x42,0x41,0x4E
	DW 0x47,0x22,0x00,0x0D,0xB4,0x52,0x45,0x54,0x00,0x0D,0xDE,0x50,0x52,0x45,0x3B,0x22
	DW 0x20,0x55,0x4E,0x49,0x54,0x53,0x20,0x4F,0x46,0x20,0x45,0x4E,0x45,0x52,0x47,0x59
	DW 0x20,0x4C,0x45,0x46,0x54,0x2E,0x22,0x00,0x0D,0xE0,0x49,0x46,0x09,0x52,0x4E,0x44
	DW 0x28,0x45,0x2F,0x34,0x29,0x2B,0x31,0x3E,0x54,0x20,0x52,0x45,0x54,0x00,0x0E,0x10
	DW 0x49,0x46,0x40,0x37,0x30,0x3D,0x30,0x20,0x40,0x37,0x30,0x3D,0x52,0x4E,0x44,0x28
	DW 0x54,0x2F,0x35,0x30,0x2B,0x31,0x29,0x2B,0x31,0x3A,0x4A,0x3D,0x37,0x3A,0x47,0x4F
	DW 0x54,0x4F,0x33,0x37,0x35,0x30,0x00,0x0E,0x42,0x4A,0x3D,0x52,0x4E,0x44,0x28,0x35
	DW 0x29,0x2B,0x31,0x3A,0x40,0x28,0x4A,0x2B,0x36,0x33,0x29,0x3D,0x52,0x4E,0x44,0x28
	DW 0x54,0x2F,0x39,0x30,0x2B,0x31,0x29,0x2B,0x31,0x00,0x0E,0xA6,0x49,0x3D,0x40,0x28
	DW 0x4A,0x2B,0x36,0x33,0x29,0x00,0x0E,0xA8,0x49,0x46,0x4A,0x3D,0x31,0x20,0x50,0x52
	DW 0x22,0x53,0x48,0x4F,0x52,0x54,0x20,0x52,0x41,0x4E,0x47,0x45,0x20,0x53,0x45,0x4E
	DW 0x53,0x4F,0x52,0x20,0x20,0x22,0x3B,0x00,0x0E,0xD8,0x49,0x46,0x4A,0x3D,0x32,0x20
	DW 0x50,0x52,0x22,0x43,0x4F,0x4D,0x50,0x55,0x54,0x45,0x52,0x20,0x44,0x49,0x53,0x50
	DW 0x4C,0x41,0x59,0x20,0x20,0x22,0x3B,0x00,0x0F,0x0A,0x49,0x46,0x4A,0x3D,0x33,0x20
	DW 0x50,0x52,0x22,0x4C,0x4F,0x4E,0x47,0x20,0x52,0x41,0x4E,0x47,0x45,0x20,0x53,0x45
	DW 0x4E,0x53,0x4F,0x52,0x20,0x20,0x22,0x3B,0x00,0x0F,0x3C,0x49,0x46,0x4A,0x3D,0x34
	DW 0x20,0x50,0x52,0x22,0x50,0x48,0x41,0x53,0x45,0x52,0x20,0x20,0x22,0x3B,0x00,0x0F
	DW 0x6E,0x49,0x46,0x4A,0x3D,0x35,0x20,0x50,0x52,0x22,0x50,0x48,0x4F,0x54,0x4F,0x4E
	DW 0x20,0x54,0x4F,0x52,0x50,0x45,0x44,0x4F,0x20,0x54,0x55,0x42,0x45,0x53,0x20,0x20
	DW 0x22,0x3B,0x00,0x0F,0xA0,0x49,0x46,0x4A,0x3D,0x36,0x20,0x50,0x52,0x22,0x57,0x41
	DW 0x52,0x50,0x20,0x45,0x4E,0x47,0x49,0x4E,0x45,0x20,0x20,0x22,0x3B,0x00,0x0F,0xD2
	DW 0x49,0x46,0x4A,0x3D,0x37,0x20,0x50,0x52,0x22,0x53,0x48,0x49,0x45,0x4C,0x44,0x20
	DW 0x20,0x22,0x3B,0x00,0x10,0x04,0x49,0x46,0x49,0x3D,0x30,0x20,0x52,0x45,0x54,0x00
	DW 0x10,0x36,0x50,0x52,0x22,0x20,0x44,0x41,0x4D,0x41,0x47,0x45,0x44,0x2C,0x20,0x22
	DW 0x3B,0x49,0x3B,0x22,0x20,0x53,0x54,0x41,0x52,0x44,0x41,0x54,0x45,0x53,0x20,0x45
	DW 0x53,0x54,0x49,0x4D,0x41,0x54,0x45,0x44,0x20,0x46,0x4F,0x52,0x20,0x52,0x45,0x50
	DW 0x41,0x49,0x52,0x22,0x00,0x10,0x38,0x52,0x45,0x54,0x00,0x10,0x68,0x50,0x52,0x22
	DW 0x53,0x54,0x41,0x54,0x55,0x53,0x20,0x52,0x45,0x50,0x4F,0x52,0x54,0x22,0x00,0x10
	DW 0x6A,0x50,0x52,0x22,0x53,0x54,0x41,0x52,0x20,0x44,0x41,0x54,0x45,0x20,0x22,0x3B
	DW 0x33,0x32,0x33,0x30,0x2D,0x44,0x3B,0x22,0x20,0x54,0x49,0x4D,0x45,0x20,0x4C,0x45
	DW 0x46,0x54,0x20,0x22,0x3B,0x44,0x00,0x10,0x6C,0x50,0x52,0x22,0x43,0x4F,0x4E,0x44
	DW 0x49,0x54,0x49,0x4F,0x4E,0x20,0x22,0x3B,0x00,0x10,0x6E,0x49,0x46,0x4F,0x3D,0x30
	DW 0x20,0x47,0x4F,0x54,0x4F,0x34,0x32,0x31,0x32,0x00,0x10,0x70,0x50,0x52,0x22,0x44
	DW 0x4F,0x43,0x4B,0x45,0x44,0x22,0x00,0x10,0x72,0x47,0x4F,0x54,0x4F,0x34,0x34,0x35
	DW 0x30,0x00,0x10,0x74,0x49,0x46,0x4E,0x3D,0x30,0x20,0x47,0x4F,0x54,0x4F,0x34,0x32
	DW 0x31,0x38,0x00,0x10,0x76,0x50,0x52,0x22,0x52,0x45,0x44,0x22,0x00,0x10,0x78,0x47
	DW 0x4F,0x54,0x4F,0x34,0x34,0x35,0x30,0x00,0x10,0x7A,0x49,0x46,0x45,0x3E,0x39,0x39
	DW 0x39,0x20,0x47,0x4F,0x54,0x4F,0x34,0x32,0x32,0x34,0x00,0x10,0x7C,0x50,0x52,0x22
	DW 0x59,0x45,0x4C,0x4C,0x4F,0x57,0x22,0x00,0x10,0x7E,0x47,0x4F,0x54,0x4F,0x34,0x34
	DW 0x35,0x30,0x00,0x10,0x80,0x50,0x52,0x22,0x47,0x52,0x45,0x45,0x4E,0x22,0x00,0x11
	DW 0x62,0x47,0x4F,0x53,0x55,0x42,0x20,0x31,0x37,0x35,0x30,0x00,0x11,0x64,0x50,0x52
	DW 0x22,0x45,0x4E,0x45,0x52,0x47,0x59,0x20,0x22,0x3B,0x45,0x00,0x11,0x94,0x50,0x52
	DW 0x22,0x54,0x4F,0x52,0x50,0x45,0x44,0x4F,0x45,0x53,0x20,0x22,0x3B,0x46,0x00,0x11
	DW 0x96,0x50,0x52,0x22,0x4B,0x4C,0x49,0x4E,0x47,0x4F,0x4E,0x53,0x20,0x4C,0x45,0x46
	DW 0x54,0x20,0x22,0x3B,0x4B,0x00,0x11,0x98,0x50,0x52,0x22,0x53,0x54,0x41,0x52,0x42
	DW 0x41,0x53,0x45,0x53,0x20,0x22,0x3B,0x42,0x00,0x11,0xC6,0x4A,0x3D,0x31,0x00,0x11
	DW 0xC8,0x49,0x46,0x40,0x28,0x4A,0x2B,0x36,0x33,0x29,0x3E,0x30,0x20,0x47,0x4F,0x53
	DW 0x55,0x42,0x20,0x33,0x37,0x35,0x30,0x00,0x11,0xF8,0x4A,0x3D,0x4A,0x2B,0x31,0x3A
	DW 0x49,0x46,0x4A,0x3C,0x3D,0x37,0x20,0x47,0x4F,0x54,0x4F,0x34,0x35,0x35,0x32,0x00
	DW 0x11,0xFC,0x47,0x4F,0x54,0x4F,0x31,0x32,0x30,0x30,0x00,0x12,0x2A,0x4A,0x3D,0x36
	DW 0x3A,0x47,0x4F,0x53,0x55,0x42,0x20,0x33,0x37,0x35,0x30,0x00,0x12,0x2E,0x49,0x46
	DW 0x49,0x3D,0x30,0x20,0x50,0x52,0x00,0x12,0x5C,0x49,0x4E,0x20,0x22,0x53,0x45,0x43
	DW 0x54,0x4F,0x52,0x20,0x44,0x49,0x53,0x54,0x41,0x4E,0x43,0x45,0x20,0x22,0x2C,0x57
	DW 0x00,0x12,0x60,0x49,0x46,0x57,0x3C,0x31,0x20,0x47,0x4F,0x54,0x4F,0x31,0x32,0x30
	DW 0x30,0x00,0x12,0xC0,0x49,0x46,0x57,0x3C,0x3D,0x39,0x31,0x20,0x47,0x4F,0x20,0x54
	DW 0x4F,0x20,0x34,0x38,0x35,0x30,0x00,0x12,0xC2,0x57,0x3D,0x39,0x31,0x00,0x12,0xC4
	DW 0x50,0x52,0x22,0x53,0x50,0x4F,0x43,0x4B,0x3A,0x20,0x41,0x52,0x45,0x20,0x59,0x4F
	DW 0x55,0x20,0x53,0x55,0x52,0x45,0x20,0x43,0x41,0x50,0x54,0x41,0x49,0x4E,0x20,0x3F
	DW 0x3F,0x3F,0x22,0x00,0x12,0xF2,0x49,0x46,0x45,0x3E,0x3D,0x57,0x2A,0x57,0x2F,0x32
	DW 0x20,0x47,0x4F,0x54,0x4F,0x34,0x39,0x30,0x30,0x00,0x12,0xF4,0x50,0x52,0x22,0x53
	DW 0x43,0x4F,0x54,0x54,0x59,0x3A,0x53,0x49,0x52,0x2C,0x57,0x45,0x20,0x44,0x4F,0x20
	DW 0x4E,0x4F,0x54,0x20,0x48,0x41,0x56,0x45,0x20,0x54,0x48,0x45,0x20,0x45,0x4E,0x41
	DW 0x47,0x59,0x2E,0x22,0x00,0x12,0xF6,0x47,0x4F,0x54,0x4F,0x31,0x32,0x30,0x30,0x00
	DW 0x13,0x24,0x47,0x4F,0x53,0x55,0x42,0x20,0x36,0x31,0x35,0x30,0x00,0x13,0x26,0x49
	DW 0x46,0x52,0x3D,0x30,0x20,0x47,0x4F,0x54,0x4F,0x31,0x32,0x30,0x30,0x00,0x13,0x56
	DW 0x44,0x3D,0x44,0x2D,0x31,0x3A,0x4F,0x3D,0x30,0x3A,0x45,0x3D,0x45,0x2D,0x57,0x2A
	DW 0x57,0x2F,0x32,0x3A,0x40,0x28,0x38,0x2A,0x58,0x2B,0x59,0x2B,0x36,0x32,0x29,0x3D
	DW 0x30,0x3A,0x4D,0x3D,0x36,0x34,0x00,0x13,0x8A,0x40,0x4D,0x3D,0x40,0x4D,0x2D,0x28
	DW 0x40,0x4D,0x3E,0x30,0x29,0x3A,0x4D,0x3D,0x4D,0x2B,0x31,0x3A,0x49,0x46,0x4D,0x3C
	DW 0x3D,0x37,0x30,0x20,0x47,0x4F,0x54,0x4F,0x35,0x30,0x30,0x32,0x00,0x13,0xBA,0x50
	DW 0x3D,0x34,0x35,0x2A,0x58,0x2B,0x32,0x32,0x3A,0x47,0x3D,0x34,0x35,0x2A,0x59,0x2B
	DW 0x32,0x32,0x3A,0x57,0x3D,0x34,0x35,0x2A,0x57,0x3A,0x4D,0x3D,0x31,0x00,0x13,0xC2
	DW 0x57,0x3D,0x57,0x2D,0x52,0x3A,0x49,0x46,0x57,0x3C,0x2D,0x32,0x32,0x20,0x47,0x4F
	DW 0x54,0x4F,0x35,0x32,0x35,0x30,0x00,0x13,0xEC,0x50,0x3D,0x50,0x2B,0x53,0x3A,0x47
	DW 0x3D,0x47,0x2B,0x54,0x3A,0x49,0x3D,0x50,0x2F,0x34,0x35,0x3A,0x4A,0x3D,0x47,0x2F
	DW 0x34,0x35,0x00,0x13,0xF4,0x49,0x46,0x28,0x49,0x3C,0x31,0x29,0x2B,0x28,0x49,0x3E
	DW 0x38,0x29,0x2B,0x28,0x4A,0x3C,0x31,0x29,0x2B,0x28,0x4A,0x3E,0x38,0x29,0x3E,0x30
	DW 0x20,0x47,0x4F,0x54,0x4F,0x35,0x33,0x30,0x30,0x00,0x14,0x20,0x49,0x46,0x40,0x28
	DW 0x38,0x2A,0x49,0x2B,0x4A,0x2B,0x36,0x32,0x29,0x3D,0x30,0x20,0x58,0x3D,0x49,0x3A
	DW 0x59,0x3D,0x4A,0x3A,0x4D,0x3D,0x4D,0x2B,0x31,0x3A,0x49,0x46,0x4D,0x3C,0x3D,0x38
	DW 0x20,0x47,0x4F,0x54,0x4F,0x35,0x30,0x35,0x38,0x00,0x14,0x50,0x50,0x52,0x22,0x2A
	DW 0x2A,0x20,0x45,0x4D,0x45,0x52,0x47,0x45,0x4E,0x43,0x59,0x20,0x53,0x54,0x4F,0x50
	DW 0x20,0x2A,0x2A,0x22,0x00,0x14,0x52,0x50,0x52,0x22,0x53,0x50,0x4F,0x43,0x4B,0x3A
	DW 0x20,0x54,0x4F,0x20,0x45,0x52,0x52,0x4F,0x52,0x20,0x49,0x53,0x20,0x48,0x55,0x4D
	DW 0x41,0x4E,0x22,0x00,0x14,0x82,0x40,0x28,0x38,0x2A,0x58,0x2B,0x59,0x2B,0x36,0x32
	DW 0x29,0x3D,0x34,0x3A,0x47,0x4F,0x53,0x55,0x42,0x20,0x31,0x37,0x35,0x30,0x00,0x14
	DW 0x86,0x47,0x4F,0x54,0x4F,0x36,0x35,0x30,0x00,0x14,0xB4,0x50,0x3D,0x55,0x2A,0x37
	DW 0x32,0x2B,0x50,0x2F,0x35,0x2B,0x57,0x2F,0x35,0x2A,0x53,0x2F,0x52,0x2D,0x39,0x3A
	DW 0x55,0x3D,0x50,0x2F,0x37,0x32,0x3A,0x47,0x3D,0x56,0x2A,0x37,0x32,0x2B,0x47,0x2F
	DW 0x35,0x2B,0x57,0x2F,0x35,0x2A,0x54,0x2F,0x52,0x2D,0x39,0x3A,0x56,0x3D,0x47,0x2F
	DW 0x37,0x32,0x00,0x14,0xE6,0x49,0x46,0x52,0x4E,0x44,0x28,0x39,0x29,0x3E,0x32,0x20
	DW 0x47,0x4F,0x54,0x4F,0x35,0x34,0x30,0x30,0x00,0x14,0xE8,0x50,0x52,0x22,0x2A,0x2A
	DW 0x20,0x53,0x50,0x41,0x43,0x45,0x20,0x53,0x54,0x4F,0x52,0x4D,0x20,0x2A,0x2A,0x22
	DW 0x00,0x14,0xEA,0x54,0x3D,0x31,0x30,0x30,0x3A,0x47,0x4F,0x53,0x55,0x42,0x20,0x33
	DW 0x36,0x30,0x30,0x00,0x15,0x18,0x49,0x46,0x28,0x55,0x3E,0x30,0x29,0x2B,0x28,0x55
	DW 0x3C,0x39,0x29,0x2B,0x28,0x56,0x3E,0x30,0x29,0x2B,0x28,0x56,0x3C,0x39,0x29,0x3D
	DW 0x34,0x20,0x58,0x3D,0x28,0x50,0x2B,0x39,0x2D,0x37,0x32,0x2A,0x55,0x29,0x2F,0x39
	DW 0x3A,0x59,0x3D,0x28,0x47,0x2B,0x39,0x2D,0x37,0x32,0x2A,0x56,0x29,0x2F,0x39,0x3A
	DW 0x47,0x4F,0x54,0x4F,0x34,0x35,0x30,0x00,0x15,0x4A,0x50,0x52,0x22,0x2A,0x2A,0x20
	DW 0x59,0x4F,0x55,0x20,0x57,0x41,0x4E,0x44,0x45,0x52,0x45,0x44,0x20,0x4F,0x55,0x54
	DW 0x53,0x49,0x44,0x45,0x20,0x4F,0x46,0x20,0x54,0x48,0x45,0x20,0x47,0x41,0x4C,0x41
	DW 0x58,0x59,0x20,0x2A,0x2A,0x22,0x00,0x15,0x90,0x47,0x4F,0x54,0x4F,0x34,0x30,0x30
	DW 0x00,0x15,0xAE,0x4A,0x3D,0x35,0x3A,0x47,0x4F,0x53,0x55,0x42,0x20,0x33,0x37,0x35
	DW 0x30,0x00,0x15,0xB2,0x49,0x46,0x49,0x3C,0x3E,0x30,0x20,0x47,0x4F,0x54,0x4F,0x31
	DW 0x32,0x30,0x30,0x00,0x15,0xE0,0x49,0x46,0x46,0x3C,0x3E,0x30,0x20,0x47,0x4F,0x54
	DW 0x4F,0x35,0x36,0x35,0x30,0x00,0x15,0xE2,0x50,0x52,0x22,0x45,0x4D,0x50,0x54,0x59
	DW 0x22,0x00,0x15,0xE4,0x47,0x4F,0x54,0x4F,0x31,0x32,0x30,0x30,0x00,0x16,0x12,0x50
	DW 0x52,0x22,0x4C,0x4F,0x41,0x44,0x45,0x44,0x22,0x00,0x16,0x14,0x47,0x4F,0x53,0x55
	DW 0x42,0x20,0x36,0x31,0x35,0x30,0x00,0x16,0x16,0x49,0x46,0x52,0x3D,0x30,0x20,0x47
	DW 0x4F,0x54,0x4F,0x31,0x32,0x30,0x30,0x00,0x16,0x44,0x50,0x52,0x22,0x54,0x4F,0x52
	DW 0x50,0x45,0x44,0x4F,0x20,0x54,0x52,0x41,0x43,0x4B,0x20,0x22,0x3B,0x00,0x16,0x46
	DW 0x46,0x3D,0x46,0x2D,0x31,0x3A,0x4D,0x3D,0x31,0x3A,0x50,0x3D,0x34,0x35,0x2A,0x58
	DW 0x2B,0x32,0x32,0x3A,0x47,0x3D,0x34,0x35,0x2A,0x59,0x2B,0x32,0x32,0x00,0x16,0x76
	DW 0x50,0x3D,0x50,0x2B,0x53,0x3A,0x47,0x3D,0x47,0x2B,0x54,0x3A,0x49,0x3D,0x50,0x2F
	DW 0x34,0x35,0x3A,0x4A,0x3D,0x47,0x2F,0x34,0x35,0x3A,0x49,0x46,0x28,0x49,0x3E,0x30
	DW 0x29,0x2B,0x28,0x49,0x3C,0x39,0x29,0x2B,0x28,0x4A,0x3E,0x30,0x29,0x2B,0x28,0x4A
	DW 0x3C,0x39,0x29,0x3C,0x34,0x20,0x47,0x4F,0x54,0x4F,0x35,0x38,0x35,0x30,0x00,0x16
	DW 0x78,0x50,0x52,0x22,0x20,0x22,0x3B,0x49,0x3B,0x22,0x2C,0x22,0x3B,0x4A,0x3B,0x22
	DW 0x20,0x22,0x3B,0x00,0x16,0xA8,0x4C,0x3D,0x38,0x2A,0x49,0x2B,0x4A,0x2B,0x36,0x32
	DW 0x3A,0x57,0x3D,0x38,0x2A,0x55,0x2B,0x56,0x2D,0x39,0x3A,0x47,0x4F,0x54,0x4F,0x35
	DW 0x38,0x35,0x30,0x2B,0x35,0x30,0x2A,0x40,0x28,0x4C,0x29,0x00,0x16,0xDA,0x4D,0x3D
	DW 0x4D,0x2B,0x31,0x3A,0x49,0x46,0x4D,0x3C,0x3D,0x38,0x20,0x47,0x4F,0x54,0x4F,0x35
	DW 0x37,0x35,0x30,0x00,0x16,0xDC,0x50,0x52,0x22,0x4D,0x49,0x53,0x53,0x45,0x44,0x22
	DW 0x00,0x16,0xDE,0x47,0x4F,0x54,0x4F,0x36,0x35,0x30,0x00,0x17,0x0C,0x53,0x3D,0x33
	DW 0x30,0x30,0x3A,0x4D,0x3D,0x31,0x33,0x35,0x00,0x17,0x10,0x49,0x46,0x28,0x40,0x28
	DW 0x4D,0x2B,0x36,0x29,0x3D,0x49,0x29,0x2A,0x28,0x40,0x28,0x4D,0x2B,0x31,0x32,0x29
	DW 0x3D,0x4A,0x29,0x3D,0x31,0x20,0x47,0x4F,0x54,0x4F,0x35,0x39,0x32,0x36,0x00,0x17
	DW 0x20,0x4D,0x3D,0x4D,0x2B,0x31,0x3A,0x49,0x46,0x4D,0x3C,0x3D,0x31,0x34,0x30,0x20
	DW 0x47,0x4F,0x54,0x4F,0x35,0x39,0x30,0x34,0x00,0x17,0x26,0x47,0x4F,0x53,0x55,0x42
	DW 0x20,0x33,0x30,0x35,0x30,0x00,0x17,0x28,0x47,0x4F,0x54,0x4F,0x36,0x35,0x30,0x00
	DW 0x17,0x3E,0x42,0x3D,0x42,0x2D,0x31,0x3A,0x40,0x4C,0x3D,0x30,0x3A,0x40,0x57,0x3D
	DW 0x40,0x57,0x2D,0x31,0x30,0x00,0x17,0x44,0x50,0x52,0x22,0x53,0x54,0x41,0x52,0x42
	DW 0x41,0x53,0x45,0x20,0x44,0x45,0x53,0x54,0x52,0x4F,0x59,0x45,0x44,0x22,0x00,0x17
	DW 0x52,0x50,0x52,0x22,0x53,0x50,0x4F,0x43,0x4B,0x3A,0x20,0x49,0x20,0x4F,0x46,0x54
	DW 0x45,0x4E,0x20,0x46,0x49,0x4E,0x44,0x20,0x48,0x55,0x4D,0x41,0x4E,0x20,0x42,0x45
	DW 0x48,0x41,0x56,0x49,0x4F,0x55,0x52,0x20,0x46,0x41,0x53,0x43,0x49,0x4E,0x41,0x54
	DW 0x49,0x4E,0x47,0x2E,0x22,0x00,0x17,0x54,0x47,0x4F,0x54,0x4F,0x36,0x35,0x30,0x00
	DW 0x17,0x70,0x50,0x52,0x22,0x48,0x49,0x54,0x20,0x41,0x20,0x53,0x54,0x41,0x52,0x22
	DW 0x00,0x17,0x72,0x49,0x46,0x52,0x4E,0x44,0x28,0x39,0x29,0x3E,0x33,0x20,0x47,0x4F
	DW 0x54,0x4F,0x36,0x30,0x35,0x30,0x00,0x17,0x74,0x50,0x52,0x22,0x54,0x4F,0x52,0x50
	DW 0x45,0x44,0x4F,0x20,0x41,0x42,0x53,0x4F,0x52,0x42,0x45,0x44,0x22,0x00,0x17,0x76
	DW 0x47,0x4F,0x54,0x4F,0x36,0x35,0x30,0x00,0x17,0xA2,0x40,0x4C,0x3D,0x30,0x3A,0x40
	DW 0x57,0x3D,0x40,0x57,0x2D,0x31,0x00,0x17,0xA4,0x50,0x52,0x22,0x53,0x54,0x41,0x52
	DW 0x20,0x44,0x45,0x53,0x54,0x52,0x4F,0x59,0x45,0x44,0x22,0x00,0x17,0xAA,0x47,0x4F
	DW 0x54,0x4F,0x36,0x35,0x30,0x00,0x18,0x06,0x49,0x4E,0x20,0x22,0x43,0x4F,0x55,0x52
	DW 0x53,0x45,0x20,0x28,0x30,0x2D,0x33,0x36,0x30,0x29,0x20,0x22,0x2C,0x49,0x00,0x18
	DW 0x0A,0x49,0x46,0x28,0x49,0x3C,0x30,0x29,0x2B,0x28,0x49,0x3E,0x33,0x36,0x30,0x29
	DW 0x3D,0x31,0x20,0x52,0x3D,0x30,0x3A,0x52,0x45,0x54,0x00,0x18,0x38,0x53,0x3D,0x28
	DW 0x49,0x2B,0x34,0x35,0x29,0x2F,0x39,0x30,0x3A,0x49,0x3D,0x49,0x2D,0x53,0x2A,0x39
	DW 0x30,0x3A,0x52,0x3D,0x28,0x34,0x35,0x2B,0x49,0x2A,0x49,0x29,0x2F,0x31,0x31,0x30
	DW 0x2B,0x34,0x35,0x3A,0x47,0x4F,0x54,0x4F,0x36,0x32,0x35,0x30,0x2B,0x35,0x30,0x2A
	DW 0x53,0x2A,0x28,0x53,0x3C,0x34,0x29,0x00,0x18,0x6A,0x53,0x3D,0x2D,0x34,0x35,0x3A
	DW 0x54,0x3D,0x49,0x3A,0x52,0x45,0x54,0x00,0x18,0x9C,0x53,0x3D,0x49,0x3A,0x54,0x3D
	DW 0x34,0x35,0x3A,0x52,0x45,0x54,0x00,0x18,0xCE,0x53,0x3D,0x34,0x35,0x3A,0x54,0x3D
	DW 0x2D,0x49,0x3A,0x52,0x45,0x54,0x00,0x19,0x00,0x53,0x3D,0x2D,0x49,0x3A,0x54,0x3D
	DW 0x2D,0x34,0x35,0x3A,0x52,0x45,0x54,0x00,0x19,0x64,0x50,0x52,0x00,0x19,0x66,0x50
	DW 0x52,0x22,0x4D,0x49,0x53,0x53,0x49,0x4F,0x4E,0x20,0x41,0x43,0x43,0x4F,0x4D,0x50
	DW 0x4C,0x49,0x53,0x48,0x45,0x44,0x2E,0x22,0x00,0x19,0x68,0x49,0x46,0x44,0x3E,0x33
	DW 0x20,0x50,0x52,0x22,0x42,0x4F,0x59,0x2C,0x59,0x4F,0x55,0x20,0x42,0x41,0x52,0x45
	DW 0x4C,0x59,0x20,0x4D,0x41,0x44,0x45,0x20,0x49,0x54,0x2E,0x22,0x00,0x19,0x6A,0x49
	DW 0x46,0x44,0x3E,0x35,0x20,0x50,0x52,0x22,0x47,0x4F,0x4F,0x44,0x20,0x57,0x4F,0x52
	DW 0x4B,0x2E,0x22,0x00,0x19,0x6C,0x49,0x46,0x44,0x3E,0x39,0x20,0x50,0x52,0x22,0x46
	DW 0x41,0x4E,0x54,0x41,0x53,0x54,0x49,0x43,0x2E,0x22,0x00,0x19,0x6E,0x49,0x46,0x44
	DW 0x3E,0x31,0x33,0x20,0x50,0x52,0x22,0x55,0x4E,0x42,0x45,0x4C,0x49,0x45,0x56,0x41
	DW 0x42,0x4C,0x45,0x2E,0x22,0x00,0x19,0x70,0x53,0x54,0x4F,0x50,0x22,0x47,0x41,0x4D
	DW 0x45,0x20,0x46,0x49,0x4E,0x49,0x53,0x48,0x45,0x44,0x2E,0x22,0x00,0x19,0xC8,0x50
	DW 0x52,0x22,0x49,0x54,0x27,0x53,0x20,0x54,0x4F,0x4F,0x20,0x4C,0x41,0x54,0x45,0x22
	DW 0x00,0x19,0xCA,0x53,0x54,0x4F,0x50,0x20,0x22,0x54,0x48,0x45,0x20,0x46,0x45,0x44
	DW 0x45,0x52,0x41,0x54,0x49,0x4F,0x4E,0x20,0x48,0x41,0x53,0x20,0x42,0x45,0x45,0x4E
	DW 0x20,0x43,0x4F,0x4E,0x51,0x55,0x45,0x52,0x45,0x44,0x2E,0x22,0x00,0x1A,0x2C,0x53
	DW 0x54,0x4F,0x50,0x20,0x22,0x45,0x4E,0x54,0x45,0x52,0x50,0x52,0x49,0x53,0x45,0x20
	DW 0x44,0x45,0x53,0x54,0x52,0x4F,0x59,0x45,0x44,0x2E,0x22,0x00,0xD0,0xD0

;----------------------  PROGRAM LOADER  ----------------------
;               
;PC_flash:    C1h          AddrH  AddrL  nr  ...(DataLo DataHi)...  crc
;PIC_response:   id   K                                                 K

	org 	Loader
					;init int clock & serial port
	banksel	OSCCON			;BANK
	bsf	OSCCON,6		;internal clock 16MHz

	call	pps
	bcf 	PPSLOCK,PPSLOCKED	;unlock PPS
	banksel	RA0PPS			;BANK
	movwf	RA0PPS+.20		;set TX
	call	pps
	bsf 	PPSLOCK,PPSLOCKED	;lock PPS

	banksel	ANSELC			;BANK
	clrf	ANSELC			;ANSELC

	banksel	TX1STA			;BANK
	movlw	b'00100100'
	movwf	TX1STA			;set TX1STA
	movlw	0x33			;16MHz/19200bd
	movwf	SP1BRGL			;set SP1BRGL
	movlw	b'10010000'
	movwf	RC1STA			;set RC1STA

					;wait for computer
	call	Receive			
	sublw	0xC1			;Expect C1
	skpz
	bra	way_to_exit
	movlw	0x29			;PIC type
	movwf	TX1REG

MainLoop:
	movlw 	'B'
mainl:
	movwf	TX1REG
	clrf	crc
	call	Receive			;H
	movwf	PMADRH
	movwf	Temp
	call	Receive			;L
	movwf	PMADRL
	call	Receive			;count
	movwf	i

rcvoct:
	call	Receive			;data L
	movwf	PMDATL
	decf	i,f
	call	Receive			;data H
	movwf	PMDATH
	movlw 	((1<<LWLO) | (1<<WREN))	;write Latches
	call	wr_w
	incf	PMADRL,f
	decfsz	i,f
	bra	rcvoct

	call	Receive			;crc
ziieroare:
	movlw 	'N'
	skpz
	bra	mainl

	movf	Temp,w			;++
	skpnz				;++
	bra	MainLoop		;++
	incf	Temp,w			;++
	btfsc	WREG,5			;++
	bra	MainLoop		;++

	decf	PMADRL,f		;PMADRL=PMADRL-1
	call	wr_e 			;erase operation
	call	wr_w			;write operation
	bra	MainLoop

pps
	banksel	PPSLOCK			;BANK
	movlw 	0x55
	movwf 	PPSLOCK
	movlw 	0xAA
	movwf 	PPSLOCK
	retlw	B'00010100'		;select TX

Receive:
	movlw	16000000/2000000+1	;for 20MHz => 11 => 1second
	movwf	cnt1
rpt2:
	clrf	cnt2
rpt3:
	clrf	cnt3
rptc:
	banksel	PIR1
	movf 	PIR1,W			;test RX
	banksel	RC1REG
	btfss 	WREG,RCIF
	bra 	$+4			;not recive
	movf 	RC1REG,w		;return in w
	addwf 	crc,f			;compute checksum
	return

	decfsz	cnt3,f
	bra	rptc
	decfsz	cnt2,f
	bra	rpt3
	decfsz	cnt1,f
	bra	rpt2
					;timeout:
way_to_exit:				;exit in all other cases; must be BANK3
	clrf	PMCON1
	movlb	.0			;BANK0
	clrf	PCLATH			;PAGE0
	clrf	LDFLG			;++
	goto	RRESET			;++

wr_e:
	movlw 	((1<<FREE) | (1<<WREN))
wr_w:
	movwf	PMCON1
	movlw	0x55
	movwf	PMCON2
	movlw	0xaa
	movwf	PMCON2
	bsf	PMCON1,WR
	nop
	nop
	retlw	((1<<WREN))

;*************************************************************
; After reset
; Do not expect the memory to be zero,
; Do not expect registers to be initialised like in catalog.

	END

